import { VfField, LayoutTemplate } from '../interfaces/table';

interface Props {
    modelValue: string;
    layouts: LayoutTemplate[];
    templates: VfField[];
    actions: VfField[];
    icons: VfField[];
    data: any[];
    height?: number;
    fixed?: boolean;
}
declare const _default: import('vue').DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    layouts: () => never[];
    templates: () => never[];
    actions: () => never[];
    icons: () => never[];
    data: () => never[];
}>, {}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    "update:modelValue": (id: string) => void;
    onCta: (action: string, row: any, index: number) => void;
    error: (msg: string) => void;
    save: (layout: LayoutTemplate, callback: () => void) => void;
    remove: (id: string, callback: () => void) => void;
    setDefault: (id: string, callback: () => void) => void;
}, string, import("vue").PublicProps, Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    layouts: () => never[];
    templates: () => never[];
    actions: () => never[];
    icons: () => never[];
    data: () => never[];
}>>> & {
    onOnCta?: ((action: string, row: any, index: number) => any) | undefined;
    onError?: ((msg: string) => any) | undefined;
    onSave?: ((layout: LayoutTemplate, callback: () => void) => any) | undefined;
    "onUpdate:modelValue"?: ((id: string) => any) | undefined;
    onRemove?: ((id: string, callback: () => void) => any) | undefined;
    onSetDefault?: ((id: string, callback: () => void) => any) | undefined;
}, {
    templates: VfField[];
    data: any[];
    actions: VfField[];
    icons: VfField[];
    layouts: LayoutTemplate[];
}, {}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
