import { defineComponent as bt, ref as ue, onMounted as yt, onBeforeUnmount as zt, computed as z, openBlock as M, createElementBlock as P, normalizeClass as q, normalizeStyle as ze, createElementVNode as f, Fragment as ne, renderList as oe, toDisplayString as we, renderSlot as hn, createTextVNode as lt, h as Xn, resolveComponent as Xo, useCssVars as qo, useSlots as Go, toRefs as mo, watch as vt, watchEffect as qn, unref as ee, withKeys as Jo, createVNode as Ue, Transition as Ko, withCtx as Lt, withDirectives as fe, createBlock as Qo, createCommentVNode as En, vShow as bo, reactive as Zo, nextTick as yo, isRef as ei, vModelText as ke, pushScopeId as xn, popScopeId as On, withModifiers as ti, vModelSelect as Gn } from "vue";
var A = /* @__PURE__ */ ((t) => (t.DATA = "DATA", t.SYMBOL = "SYMBOL", t.ACTION = "ACTION", t.ICON = "ICON", t.LABEL = "LABEL", t))(A || {});
const gn = [
  {
    vfTitle: "⌴",
    vfCode: "space",
    vfType: A.SYMBOL,
    vfAcutalField: "space",
    vfActualFieldTitle: "Dấu cách",
    value: "&nbsp;"
  },
  {
    vfTitle: "↩",
    vfCode: "newline",
    vfType: A.SYMBOL,
    vfAcutalField: "newline",
    vfActualFieldTitle: "NewLine",
    value: "<br/>"
  },
  {
    vfTitle: "-",
    vfCode: "minus",
    vfType: A.SYMBOL,
    vfAcutalField: "minus",
    vfActualFieldTitle: "Dấu trừ",
    value: "&hyphen;"
  },
  {
    vfTitle: "_",
    vfCode: "underscore",
    vfType: A.SYMBOL,
    vfAcutalField: "underscore",
    vfActualFieldTitle: "Dấu gạch dưới",
    value: "_"
  },
  {
    vfTitle: "|",
    vfCode: "vertical",
    vfType: A.SYMBOL,
    vfAcutalField: "vertical",
    vfActualFieldTitle: "Dấu dọc",
    value: "|"
  },
  {
    vfTitle: ",",
    vfCode: "comma",
    vfType: A.SYMBOL,
    vfAcutalField: "comma",
    vfActualFieldTitle: "Dấu phẩy",
    value: ","
  },
  {
    vfTitle: ":",
    vfCode: "colon",
    vfType: A.SYMBOL,
    vfAcutalField: "colon",
    vfActualFieldTitle: "Hai chấm",
    value: ":"
  },
  {
    vfTitle: ".",
    vfCode: "dot",
    vfType: A.SYMBOL,
    vfAcutalField: "dot",
    vfActualFieldTitle: "Dấu chấm",
    value: "."
  },
  {
    vfTitle: ";",
    vfCode: "semicolon",
    vfType: A.SYMBOL,
    vfAcutalField: "semicolon",
    vfActualFieldTitle: "Chấm phẩy",
    value: ";"
  },
  {
    vfTitle: "/",
    vfCode: "slash",
    vfType: A.SYMBOL,
    vfAcutalField: "slash",
    vfActualFieldTitle: "Dấu gạch chéo",
    value: "/"
  },
  {
    vfTitle: "\\",
    vfCode: "backslash",
    vfType: A.SYMBOL,
    vfAcutalField: "backslash",
    vfActualFieldTitle: "Dấu gạch chéo ngược",
    value: "\\"
  },
  {
    vfTitle: "?",
    vfCode: "question",
    vfType: A.SYMBOL,
    vfAcutalField: "question",
    vfActualFieldTitle: "Dấu hỏi",
    value: "?"
  },
  {
    vfTitle: "~",
    vfCode: "tilde",
    vfType: A.SYMBOL,
    vfAcutalField: "tilde",
    vfActualFieldTitle: "Dấu ngã",
    value: "~"
  },
  {
    vfTitle: "@",
    vfCode: "at",
    vfType: A.SYMBOL,
    vfAcutalField: "at",
    vfActualFieldTitle: "Dấu @",
    value: "@"
  },
  {
    vfTitle: "#",
    vfCode: "hash",
    vfType: A.SYMBOL,
    vfAcutalField: "hash",
    vfActualFieldTitle: "Dấu #",
    value: "#"
  },
  {
    vfTitle: "$",
    vfCode: "dollar",
    vfType: A.SYMBOL,
    vfAcutalField: "dollar",
    vfActualFieldTitle: "Dấu $",
    value: "$"
  },
  {
    vfTitle: "^",
    vfCode: "caret",
    vfType: A.SYMBOL,
    vfAcutalField: "caret",
    vfActualFieldTitle: "Dấu mũ",
    value: "^"
  },
  {
    vfTitle: "&",
    vfCode: "ampersand",
    vfType: A.SYMBOL,
    vfAcutalField: "ampersand",
    vfActualFieldTitle: "Dấu &",
    value: "&"
  },
  {
    vfTitle: "*",
    vfCode: "asterisk",
    vfType: A.SYMBOL,
    vfAcutalField: "asterisk",
    vfActualFieldTitle: "Dấu *",
    value: "*"
  },
  {
    vfTitle: "[",
    vfCode: "openBracket",
    vfType: A.SYMBOL,
    vfAcutalField: "openBracket",
    vfActualFieldTitle: "Mở ngoặc vuông",
    value: "["
  },
  {
    vfTitle: "]",
    vfCode: "closeBracket",
    vfType: A.SYMBOL,
    vfAcutalField: "closeBracket",
    vfActualFieldTitle: "Đóng ngoặc vuông",
    value: "]"
  },
  {
    vfTitle: "(",
    vfCode: "openRoundBracket",
    vfType: A.SYMBOL,
    vfAcutalField: "openRoundBracket",
    vfActualFieldTitle: "Mở ngoặc tròn",
    value: "("
  },
  {
    vfTitle: ")",
    vfCode: "closeRoundBracket",
    vfType: A.SYMBOL,
    vfAcutalField: "closeRoundBracket",
    vfActualFieldTitle: "Đóng hoặc tròn",
    value: ")"
  },
  {
    vfTitle: "<",
    vfCode: "openAngleBracket",
    vfType: A.SYMBOL,
    vfAcutalField: "openAngleBracket",
    vfActualFieldTitle: "Mở ngoặc nhọn",
    value: "&lt;"
  },
  {
    vfTitle: ">",
    vfCode: "closeAngleBracket",
    vfType: A.SYMBOL,
    vfAcutalField: "closeAngleBracket",
    vfActualFieldTitle: "Đóng ngoặc nhọn",
    value: "&gt;"
  },
  {
    vfTitle: '"',
    vfCode: "doubleQuote",
    vfType: A.SYMBOL,
    vfAcutalField: "doubleQuote",
    vfActualFieldTitle: "Dấu ngoặc kép",
    value: '"'
  },
  {
    vfTitle: "'",
    vfCode: "singleQuote",
    vfType: A.SYMBOL,
    vfAcutalField: "singleQuote",
    vfActualFieldTitle: "Dấu ngoặc đơn",
    value: "'"
  },
  {
    vfTitle: "`",
    vfCode: "backtick",
    vfType: A.SYMBOL,
    vfAcutalField: "backtick",
    vfActualFieldTitle: "Dấu ngoặc ngược",
    value: "`"
  },
  {
    vfTitle: "€",
    vfCode: "euro",
    vfType: A.SYMBOL,
    vfAcutalField: "euro",
    vfActualFieldTitle: "Euro",
    value: "€"
  },
  {
    vfTitle: "£",
    vfCode: "pound",
    vfType: A.SYMBOL,
    vfAcutalField: "pound",
    vfActualFieldTitle: "Pound",
    value: "£"
  },
  {
    vfTitle: "¥",
    vfCode: "yen",
    vfType: A.SYMBOL,
    vfAcutalField: "yen",
    vfActualFieldTitle: "Yen",
    value: "¥"
  },
  {
    vfTitle: "¢",
    vfCode: "cent",
    vfType: A.SYMBOL,
    vfAcutalField: "cent",
    vfActualFieldTitle: "Cent",
    value: "¢"
  },
  {
    vfTitle: "©",
    vfCode: "copyright",
    vfType: A.SYMBOL,
    vfAcutalField: "copyright",
    vfActualFieldTitle: "Copyright",
    value: "©"
  },
  {
    vfTitle: "®",
    vfCode: "registered",
    vfType: A.SYMBOL,
    vfAcutalField: "registered",
    vfActualFieldTitle: "Registered",
    value: "®"
  },
  {
    vfTitle: "™",
    vfCode: "trademark",
    vfType: A.SYMBOL,
    vfAcutalField: "trademark",
    vfActualFieldTitle: "Trademark",
    value: "™"
  },
  {
    vfTitle: "§",
    vfCode: "section",
    vfType: A.SYMBOL,
    vfAcutalField: "section",
    vfActualFieldTitle: "Section",
    value: "§"
  },
  {
    vfTitle: "¶",
    vfCode: "paragraph",
    vfType: A.SYMBOL,
    vfAcutalField: "paragraph",
    vfActualFieldTitle: "Paragraph",
    value: "¶"
  },
  {
    vfTitle: "°",
    vfCode: "degree",
    vfType: A.SYMBOL,
    vfAcutalField: "degree",
    vfActualFieldTitle: "Degree",
    value: "°"
  },
  {
    vfTitle: "±",
    vfCode: "plusMinus",
    vfType: A.SYMBOL,
    vfAcutalField: "plusMinus",
    vfActualFieldTitle: "Plus Minus",
    value: "±"
  },
  {
    vfTitle: "×",
    vfCode: "multiply",
    vfType: A.SYMBOL,
    vfAcutalField: "multiply",
    vfActualFieldTitle: "Multiply",
    value: "×"
  },
  {
    vfTitle: "÷",
    vfCode: "divide",
    vfType: A.SYMBOL,
    vfAcutalField: "divide",
    vfActualFieldTitle: "Divide",
    value: "÷"
  },
  {
    vfTitle: "≠",
    vfCode: "notEqual",
    vfType: A.SYMBOL,
    vfAcutalField: "notEqual",
    vfActualFieldTitle: "Not Equal",
    value: "≠"
  },
  {
    vfTitle: "≤",
    vfCode: "lessThanOrEqual",
    vfType: A.SYMBOL,
    vfAcutalField: "lessThanOrEqual",
    vfActualFieldTitle: "Less Than Or Equal",
    value: "≤"
  },
  {
    vfTitle: "≥",
    vfCode: "greaterThanOrEqual",
    vfType: A.SYMBOL,
    vfAcutalField: "greaterThanOrEqual",
    vfActualFieldTitle: "Greater Than Or Equal",
    value: "≥"
  },
  {
    vfTitle: "≈",
    vfCode: "approximatelyEqual",
    vfType: A.SYMBOL,
    vfAcutalField: "approximatelyEqual",
    vfActualFieldTitle: "Approximately Equal",
    value: "≈"
  }
];
A.ACTION, A.ACTION, A.ACTION;
function ni(t) {
  return t && t.__esModule && Object.prototype.hasOwnProperty.call(t, "default") ? t.default : t;
}
/*!
 * escape-html
 * Copyright(c) 2012-2013 TJ Holowaychuk
 * Copyright(c) 2015 Andreas Lubbe
 * Copyright(c) 2015 Tiancheng "Timothy" Gu
 * MIT Licensed
 */
var oi = /["'&<>]/, ii = ri;
function ri(t) {
  var e = "" + t, n = oi.exec(e);
  if (!n)
    return e;
  var o, i = "", r = 0, a = 0;
  for (r = n.index; r < e.length; r++) {
    switch (e.charCodeAt(r)) {
      case 34:
        o = "&quot;";
        break;
      case 38:
        o = "&amp;";
        break;
      case 39:
        o = "&#39;";
        break;
      case 60:
        o = "&lt;";
        break;
      case 62:
        o = "&gt;";
        break;
      default:
        continue;
    }
    a !== r && (i += e.substring(a, r)), a = r + 1, i += o;
  }
  return a !== r ? i + e.substring(a, r) : i;
}
const Zt = /* @__PURE__ */ ni(ii), ai = { class: "dynamic-table" }, li = ["innerHTML"], si = { key: 1 }, ui = ["colspan"], ci = "tdac", di = /* @__PURE__ */ bt({
  __name: "DynamicTable",
  props: {
    columns: { default: () => [] },
    templates: { default: () => [] },
    labels: { default: () => [] },
    data: { default: () => [] },
    height: {},
    fixed: { type: Boolean, default: !1 }
  },
  emits: ["onCta"],
  setup(t, { emit: e }) {
    const n = t, o = e, i = ue("");
    yt(() => {
      i.value = `${ci}${Math.floor(Math.random() * 1e6)}`;
      const u = window;
      u[i.value] = function(y, b) {
        const p = n.data[b];
        p && o("onCta", y, p, b);
      };
    }), zt(() => {
      const u = window;
      u[i.value] && (u[i.value] = void 0, delete u[i.value]);
    });
    const r = z(() => (u, y = "", b = {}) => {
      for (const p in u)
        if (u.hasOwnProperty(p)) {
          const h = y ? `${y}.${p}` : p;
          typeof u[p] == "object" && u[p] !== null ? r.value(u[p], h, b) : b[h] = u[p];
        }
      return b;
    }), a = (u, y) => u.replace(/\{\{(.*?)\}\}/g, (b, p) => {
      const h = y[p];
      return h ?? b;
    }), l = z(() => (u) => {
      const y = {
        "text-align": u.align || "left",
        "vertical-align": u.vAlign || "top"
      };
      return u.width && (y.width = u.width), u.minWidth && (y["min-width"] = u.minWidth), u.maxWidth && (y["max-width"] = u.maxWidth), y;
    }), s = z(() => [
      ...n.templates,
      ...n.labels.map((u) => ({
        vfTitle: u.title,
        vfCode: u.code,
        vfType: A.LABEL,
        meta: u.style
      })),
      ...gn
    ].reduce((u, y) => (u[y.vfCode] = y, u), {})), c = z(() => (u) => {
      const y = n.labels.find((h) => h.code === u.vfCode), b = (y == null ? void 0 : y.style) || {}, p = Object.entries(b).map(([h, g]) => `${h.replace(/[A-Z]/g, (x) => `-${x.toLowerCase()}`)}: ${g}`);
      return b.backgroundColor && b.backgroundColor !== "transparent" && (p.push("padding: 0 3px"), p.push("border-radius: 3px")), p.join(";");
    }), d = z(() => (u, y, b) => {
      const p = [];
      for (const h of y.fieldCodes) {
        const g = s.value[h];
        if (g)
          switch (g.vfType) {
            case A.SYMBOL:
              p.push((g == null ? void 0 : g.value) || "");
              break;
            case A.ACTION:
              if (g.vfRenderFunc) {
                const m = g.vfRenderFunc(u, g, b, i.value), T = document.createElement("span");
                T.classList.add("btn"), T.classList.add(`btn-${g.vfCode}`), T.setAttribute("onClick", `${i.value}('${g.vfCode}', ${b})`), T.textContent = m, p.push(T.outerHTML);
                break;
              }
              if (g.vfAcutalField) {
                const T = r.value(u)[(g == null ? void 0 : g.vfAcutalField) || ""], v = document.createElement("span");
                v.classList.add("btn"), v.classList.add(`btn-${g.vfCode}`), v.setAttribute("onClick", `${i.value}('${g.vfCode}', ${b})`), v.textContent = T || "", p.push(v.outerHTML);
                break;
              }
              const E = document.createElement("span");
              E.classList.add("btn"), E.classList.add(`btn-${g.vfCode}`), E.setAttribute("onClick", `${i.value}('${g.vfCode}', ${b})`), E.textContent = (g == null ? void 0 : g.vfTitle) || "", p.push(E.outerHTML);
              break;
            case A.ICON:
              const x = document.createElement("img");
              x.classList.add("icon"), x.src = g.value || "", p.push(x.outerHTML);
              break;
            case A.LABEL:
              const w = document.createElement("span");
              w.style.cssText = c.value(g), w.textContent = g.vfTitle, p.push(w.outerHTML);
              break;
            default:
              let O = r.value(u)[(g == null ? void 0 : g.vfAcutalField) || ""];
              if (g.vfRenderFunc) {
                const m = g.vfRenderFunc(u, g, b, i.value, structuredClone(O));
                p.push(m);
                break;
              }
              const F = u[g.vfAcutalField];
              if (Array.isArray(F)) {
                const m = g.templateShow ? F.map((T) => a(g.templateShow, { $item: Zt(T) })).join("") : F.join(", ");
                p.push(m);
                break;
              }
              g != null && g.enum && Object.keys(g.enum).length > 0 && (O = g.enum[O] || O, O = Zt(O)), g != null && g.templateShow && (O = a(g == null ? void 0 : g.templateShow, { value: Zt(O) })), p.push(O);
              break;
          }
      }
      return p.join("");
    });
    return (u, y) => {
      var b;
      return M(), P("div", {
        class: q(["wrapper-table custom-scroll", { fixed: u.fixed }]),
        style: ze({ height: u.fixed ? `${u.height}px` : "auto" })
      }, [
        f("table", ai, [
          f("thead", null, [
            f("tr", null, [
              (M(!0), P(ne, null, oe(u.columns, (p, h) => (M(), P("th", {
                key: h,
                class: q({ "drag-over": p.isDrag })
              }, we(p.title), 3))), 128))
            ])
          ]),
          f("tbody", null, [
            (((b = u.data) == null ? void 0 : b.length) || 0) > 0 ? (M(!0), P(ne, { key: 0 }, oe(u.data, (p, h) => (M(), P("tr", { key: h }, [
              (M(!0), P(ne, null, oe(u.columns, (g, E) => (M(), P("td", {
                key: E,
                class: q({ "drag-over": g.isDrag }),
                style: ze(l.value(g))
              }, [
                f("div", {
                  class: "td-line",
                  innerHTML: d.value(p, g, h)
                }, null, 8, li)
              ], 6))), 128))
            ]))), 128)) : (M(), P("tr", si, [
              f("td", {
                colspan: u.columns.length,
                class: "no-data"
              }, [
                hn(u.$slots, "no-data", {}, () => [
                  lt(" Không có dữ liệu ")
                ], !0)
              ], 8, ui)
            ]))
          ])
        ])
      ], 6);
    };
  }
}), Xt = (t, e) => {
  const n = t.__vccOpts || t;
  for (const [o, i] of e)
    n[o] = i;
  return n;
}, Jn = /* @__PURE__ */ Xt(di, [["__scopeId", "data-v-e0be3805"]]);
/*!
  * vue-draggable-next v2.2.0
  * (c) 2023 Anish George
  * @license MIT
  */
/**!
 * Sortable 1.14.0
 * @author	RubaXa   <trash@rubaxa.org>
 * @author	owenm    <owen23355@gmail.com>
 * @license MIT
 */
function Kn(t, e) {
  var n = Object.keys(t);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(t);
    e && (o = o.filter(function(i) {
      return Object.getOwnPropertyDescriptor(t, i).enumerable;
    })), n.push.apply(n, o);
  }
  return n;
}
function Se(t) {
  for (var e = 1; e < arguments.length; e++) {
    var n = arguments[e] != null ? arguments[e] : {};
    e % 2 ? Kn(Object(n), !0).forEach(function(o) {
      fi(t, o, n[o]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(t, Object.getOwnPropertyDescriptors(n)) : Kn(Object(n)).forEach(function(o) {
      Object.defineProperty(t, o, Object.getOwnPropertyDescriptor(n, o));
    });
  }
  return t;
}
function It(t) {
  "@babel/helpers - typeof";
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? It = function(e) {
    return typeof e;
  } : It = function(e) {
    return e && typeof Symbol == "function" && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
  }, It(t);
}
function fi(t, e, n) {
  return e in t ? Object.defineProperty(t, e, {
    value: n,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : t[e] = n, t;
}
function $e() {
  return $e = Object.assign || function(t) {
    for (var e = 1; e < arguments.length; e++) {
      var n = arguments[e];
      for (var o in n)
        Object.prototype.hasOwnProperty.call(n, o) && (t[o] = n[o]);
    }
    return t;
  }, $e.apply(this, arguments);
}
function pi(t, e) {
  if (t == null)
    return {};
  var n = {}, o = Object.keys(t), i, r;
  for (r = 0; r < o.length; r++)
    i = o[r], !(e.indexOf(i) >= 0) && (n[i] = t[i]);
  return n;
}
function vi(t, e) {
  if (t == null)
    return {};
  var n = pi(t, e), o, i;
  if (Object.getOwnPropertySymbols) {
    var r = Object.getOwnPropertySymbols(t);
    for (i = 0; i < r.length; i++)
      o = r[i], !(e.indexOf(o) >= 0) && Object.prototype.propertyIsEnumerable.call(t, o) && (n[o] = t[o]);
  }
  return n;
}
var hi = "1.14.0";
function Fe(t) {
  if (typeof window < "u" && window.navigator)
    return !!/* @__PURE__ */ navigator.userAgent.match(t);
}
var Ie = Fe(/(?:Trident.*rv[ :]?11\.|msie|iemobile|Windows Phone)/i), wt = Fe(/Edge/i), Qn = Fe(/firefox/i), st = Fe(/safari/i) && !Fe(/chrome/i) && !Fe(/android/i), wo = Fe(/iP(ad|od|hone)/i), gi = Fe(/chrome/i) && Fe(/android/i), _o = {
  capture: !1,
  passive: !1
};
function N(t, e, n) {
  t.addEventListener(e, n, !Ie && _o);
}
function B(t, e, n) {
  t.removeEventListener(e, n, !Ie && _o);
}
function jt(t, e) {
  if (e) {
    if (e[0] === ">" && (e = e.substring(1)), t)
      try {
        if (t.matches)
          return t.matches(e);
        if (t.msMatchesSelector)
          return t.msMatchesSelector(e);
        if (t.webkitMatchesSelector)
          return t.webkitMatchesSelector(e);
      } catch {
        return !1;
      }
    return !1;
  }
}
function mi(t) {
  return t.host && t !== document && t.host.nodeType ? t.host : t.parentNode;
}
function Ee(t, e, n, o) {
  if (t) {
    n = n || document;
    do {
      if (e != null && (e[0] === ">" ? t.parentNode === n && jt(t, e) : jt(t, e)) || o && t === n)
        return t;
      if (t === n)
        break;
    } while (t = mi(t));
  }
  return null;
}
var Zn = /\s+/g;
function ce(t, e, n) {
  if (t && e)
    if (t.classList)
      t.classList[n ? "add" : "remove"](e);
    else {
      var o = (" " + t.className + " ").replace(Zn, " ").replace(" " + e + " ", " ");
      t.className = (o + (n ? " " + e : "")).replace(Zn, " ");
    }
}
function $(t, e, n) {
  var o = t && t.style;
  if (o) {
    if (n === void 0)
      return document.defaultView && document.defaultView.getComputedStyle ? n = document.defaultView.getComputedStyle(t, "") : t.currentStyle && (n = t.currentStyle), e === void 0 ? n : n[e];
    !(e in o) && e.indexOf("webkit") === -1 && (e = "-webkit-" + e), o[e] = n + (typeof n == "string" ? "" : "px");
  }
}
function Qe(t, e) {
  var n = "";
  if (typeof t == "string")
    n = t;
  else
    do {
      var o = $(t, "transform");
      o && o !== "none" && (n = o + " " + n);
    } while (!e && (t = t.parentNode));
  var i = window.DOMMatrix || window.WebKitCSSMatrix || window.CSSMatrix || window.MSCSSMatrix;
  return i && new i(n);
}
function To(t, e, n) {
  if (t) {
    var o = t.getElementsByTagName(e), i = 0, r = o.length;
    if (n)
      for (; i < r; i++)
        n(o[i], i);
    return o;
  }
  return [];
}
function xe() {
  var t = document.scrollingElement;
  return t || document.documentElement;
}
function G(t, e, n, o, i) {
  if (!(!t.getBoundingClientRect && t !== window)) {
    var r, a, l, s, c, d, u;
    if (t !== window && t.parentNode && t !== xe() ? (r = t.getBoundingClientRect(), a = r.top, l = r.left, s = r.bottom, c = r.right, d = r.height, u = r.width) : (a = 0, l = 0, s = window.innerHeight, c = window.innerWidth, d = window.innerHeight, u = window.innerWidth), (e || n) && t !== window && (i = i || t.parentNode, !Ie))
      do
        if (i && i.getBoundingClientRect && ($(i, "transform") !== "none" || n && $(i, "position") !== "static")) {
          var y = i.getBoundingClientRect();
          a -= y.top + parseInt($(i, "border-top-width")), l -= y.left + parseInt($(i, "border-left-width")), s = a + r.height, c = l + r.width;
          break;
        }
      while (i = i.parentNode);
    if (o && t !== window) {
      var b = Qe(i || t), p = b && b.a, h = b && b.d;
      b && (a /= h, l /= p, u /= p, d /= h, s = a + d, c = l + u);
    }
    return {
      top: a,
      left: l,
      bottom: s,
      right: c,
      width: u,
      height: d
    };
  }
}
function eo(t, e, n) {
  for (var o = Ne(t, !0), i = G(t)[e]; o; ) {
    var r = G(o)[n], a = void 0;
    if (n === "top" || n === "left" ? a = i >= r : a = i <= r, !a)
      return o;
    if (o === xe())
      break;
    o = Ne(o, !1);
  }
  return !1;
}
function Ze(t, e, n, o) {
  for (var i = 0, r = 0, a = t.children; r < a.length; ) {
    if (a[r].style.display !== "none" && a[r] !== L.ghost && (o || a[r] !== L.dragged) && Ee(a[r], n.draggable, t, !1)) {
      if (i === e)
        return a[r];
      i++;
    }
    r++;
  }
  return null;
}
function Sn(t, e) {
  for (var n = t.lastElementChild; n && (n === L.ghost || $(n, "display") === "none" || e && !jt(n, e)); )
    n = n.previousElementSibling;
  return n || null;
}
function he(t, e) {
  var n = 0;
  if (!t || !t.parentNode)
    return -1;
  for (; t = t.previousElementSibling; )
    t.nodeName.toUpperCase() !== "TEMPLATE" && t !== L.clone && (!e || jt(t, e)) && n++;
  return n;
}
function to(t) {
  var e = 0, n = 0, o = xe();
  if (t)
    do {
      var i = Qe(t), r = i.a, a = i.d;
      e += t.scrollLeft * r, n += t.scrollTop * a;
    } while (t !== o && (t = t.parentNode));
  return [e, n];
}
function bi(t, e) {
  for (var n in t)
    if (t.hasOwnProperty(n)) {
      for (var o in e)
        if (e.hasOwnProperty(o) && e[o] === t[n][o])
          return Number(n);
    }
  return -1;
}
function Ne(t, e) {
  if (!t || !t.getBoundingClientRect)
    return xe();
  var n = t, o = !1;
  do
    if (n.clientWidth < n.scrollWidth || n.clientHeight < n.scrollHeight) {
      var i = $(n);
      if (n.clientWidth < n.scrollWidth && (i.overflowX == "auto" || i.overflowX == "scroll") || n.clientHeight < n.scrollHeight && (i.overflowY == "auto" || i.overflowY == "scroll")) {
        if (!n.getBoundingClientRect || n === document.body)
          return xe();
        if (o || e)
          return n;
        o = !0;
      }
    }
  while (n = n.parentNode);
  return xe();
}
function yi(t, e) {
  if (t && e)
    for (var n in e)
      e.hasOwnProperty(n) && (t[n] = e[n]);
  return t;
}
function en(t, e) {
  return Math.round(t.top) === Math.round(e.top) && Math.round(t.left) === Math.round(e.left) && Math.round(t.height) === Math.round(e.height) && Math.round(t.width) === Math.round(e.width);
}
var ut;
function Co(t, e) {
  return function() {
    if (!ut) {
      var n = arguments, o = this;
      n.length === 1 ? t.call(o, n[0]) : t.apply(o, n), ut = setTimeout(function() {
        ut = void 0;
      }, e);
    }
  };
}
function wi() {
  clearTimeout(ut), ut = void 0;
}
function Do(t, e, n) {
  t.scrollLeft += e, t.scrollTop += n;
}
function Eo(t) {
  var e = window.Polymer, n = window.jQuery || window.Zepto;
  return e && e.dom ? e.dom(t).cloneNode(!0) : n ? n(t).clone(!0)[0] : t.cloneNode(!0);
}
var pe = "Sortable" + (/* @__PURE__ */ new Date()).getTime();
function _i() {
  var t = [], e;
  return {
    captureAnimationState: function() {
      if (t = [], !!this.options.animation) {
        var o = [].slice.call(this.el.children);
        o.forEach(function(i) {
          if (!($(i, "display") === "none" || i === L.ghost)) {
            t.push({
              target: i,
              rect: G(i)
            });
            var r = Se({}, t[t.length - 1].rect);
            if (i.thisAnimationDuration) {
              var a = Qe(i, !0);
              a && (r.top -= a.f, r.left -= a.e);
            }
            i.fromRect = r;
          }
        });
      }
    },
    addAnimationState: function(o) {
      t.push(o);
    },
    removeAnimationState: function(o) {
      t.splice(bi(t, {
        target: o
      }), 1);
    },
    animateAll: function(o) {
      var i = this;
      if (!this.options.animation) {
        clearTimeout(e), typeof o == "function" && o();
        return;
      }
      var r = !1, a = 0;
      t.forEach(function(l) {
        var s = 0, c = l.target, d = c.fromRect, u = G(c), y = c.prevFromRect, b = c.prevToRect, p = l.rect, h = Qe(c, !0);
        h && (u.top -= h.f, u.left -= h.e), c.toRect = u, c.thisAnimationDuration && en(y, u) && !en(d, u) && // Make sure animatingRect is on line between toRect & fromRect
        (p.top - u.top) / (p.left - u.left) === (d.top - u.top) / (d.left - u.left) && (s = Ci(p, y, b, i.options)), en(u, d) || (c.prevFromRect = d, c.prevToRect = u, s || (s = i.options.animation), i.animate(c, p, u, s)), s && (r = !0, a = Math.max(a, s), clearTimeout(c.animationResetTimer), c.animationResetTimer = setTimeout(function() {
          c.animationTime = 0, c.prevFromRect = null, c.fromRect = null, c.prevToRect = null, c.thisAnimationDuration = null;
        }, s), c.thisAnimationDuration = s);
      }), clearTimeout(e), r ? e = setTimeout(function() {
        typeof o == "function" && o();
      }, a) : typeof o == "function" && o(), t = [];
    },
    animate: function(o, i, r, a) {
      if (a) {
        $(o, "transition", ""), $(o, "transform", "");
        var l = Qe(this.el), s = l && l.a, c = l && l.d, d = (i.left - r.left) / (s || 1), u = (i.top - r.top) / (c || 1);
        o.animatingX = !!d, o.animatingY = !!u, $(o, "transform", "translate3d(" + d + "px," + u + "px,0)"), this.forRepaintDummy = Ti(o), $(o, "transition", "transform " + a + "ms" + (this.options.easing ? " " + this.options.easing : "")), $(o, "transform", "translate3d(0,0,0)"), typeof o.animated == "number" && clearTimeout(o.animated), o.animated = setTimeout(function() {
          $(o, "transition", ""), $(o, "transform", ""), o.animated = !1, o.animatingX = !1, o.animatingY = !1;
        }, a);
      }
    }
  };
}
function Ti(t) {
  return t.offsetWidth;
}
function Ci(t, e, n, o) {
  return Math.sqrt(Math.pow(e.top - t.top, 2) + Math.pow(e.left - t.left, 2)) / Math.sqrt(Math.pow(e.top - n.top, 2) + Math.pow(e.left - n.left, 2)) * o.animation;
}
var qe = [], tn = {
  initializeByDefault: !0
}, _t = {
  mount: function(e) {
    for (var n in tn)
      tn.hasOwnProperty(n) && !(n in e) && (e[n] = tn[n]);
    qe.forEach(function(o) {
      if (o.pluginName === e.pluginName)
        throw "Sortable: Cannot mount plugin ".concat(e.pluginName, " more than once");
    }), qe.push(e);
  },
  pluginEvent: function(e, n, o) {
    var i = this;
    this.eventCanceled = !1, o.cancel = function() {
      i.eventCanceled = !0;
    };
    var r = e + "Global";
    qe.forEach(function(a) {
      n[a.pluginName] && (n[a.pluginName][r] && n[a.pluginName][r](Se({
        sortable: n
      }, o)), n.options[a.pluginName] && n[a.pluginName][e] && n[a.pluginName][e](Se({
        sortable: n
      }, o)));
    });
  },
  initializePlugins: function(e, n, o, i) {
    qe.forEach(function(l) {
      var s = l.pluginName;
      if (!(!e.options[s] && !l.initializeByDefault)) {
        var c = new l(e, n, e.options);
        c.sortable = e, c.options = e.options, e[s] = c, $e(o, c.defaults);
      }
    });
    for (var r in e.options)
      if (e.options.hasOwnProperty(r)) {
        var a = this.modifyOption(e, r, e.options[r]);
        typeof a < "u" && (e.options[r] = a);
      }
  },
  getEventProperties: function(e, n) {
    var o = {};
    return qe.forEach(function(i) {
      typeof i.eventProperties == "function" && $e(o, i.eventProperties.call(n[i.pluginName], e));
    }), o;
  },
  modifyOption: function(e, n, o) {
    var i;
    return qe.forEach(function(r) {
      e[r.pluginName] && r.optionListeners && typeof r.optionListeners[n] == "function" && (i = r.optionListeners[n].call(e[r.pluginName], o));
    }), i;
  }
};
function Di(t) {
  var e = t.sortable, n = t.rootEl, o = t.name, i = t.targetEl, r = t.cloneEl, a = t.toEl, l = t.fromEl, s = t.oldIndex, c = t.newIndex, d = t.oldDraggableIndex, u = t.newDraggableIndex, y = t.originalEvent, b = t.putSortable, p = t.extraEventProperties;
  if (e = e || n && n[pe], !!e) {
    var h, g = e.options, E = "on" + o.charAt(0).toUpperCase() + o.substr(1);
    window.CustomEvent && !Ie && !wt ? h = new CustomEvent(o, {
      bubbles: !0,
      cancelable: !0
    }) : (h = document.createEvent("Event"), h.initEvent(o, !0, !0)), h.to = a || n, h.from = l || n, h.item = i || n, h.clone = r, h.oldIndex = s, h.newIndex = c, h.oldDraggableIndex = d, h.newDraggableIndex = u, h.originalEvent = y, h.pullMode = b ? b.lastPutMode : void 0;
    var x = Se(Se({}, p), _t.getEventProperties(o, e));
    for (var w in x)
      h[w] = x[w];
    n && n.dispatchEvent(h), g[E] && g[E].call(e, h);
  }
}
var Ei = ["evt"], se = function(e, n) {
  var o = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, i = o.evt, r = vi(o, Ei);
  _t.pluginEvent.bind(L)(e, n, Se({
    dragEl: _,
    parentEl: Y,
    ghostEl: I,
    rootEl: R,
    nextEl: We,
    lastDownEl: Mt,
    cloneEl: j,
    cloneHidden: Be,
    dragStarted: it,
    putSortable: Z,
    activeSortable: L.active,
    originalEvent: i,
    oldIndex: Ke,
    oldDraggableIndex: ct,
    newIndex: de,
    newDraggableIndex: Pe,
    hideGhostForTarget: Ao,
    unhideGhostForTarget: ko,
    cloneNowHidden: function() {
      Be = !0;
    },
    cloneNowShown: function() {
      Be = !1;
    },
    dispatchSortableEvent: function(l) {
      ae({
        sortable: n,
        name: l,
        originalEvent: i
      });
    }
  }, r));
};
function ae(t) {
  Di(Se({
    putSortable: Z,
    cloneEl: j,
    targetEl: _,
    rootEl: R,
    oldIndex: Ke,
    oldDraggableIndex: ct,
    newIndex: de,
    newDraggableIndex: Pe
  }, t));
}
var _, Y, I, R, We, Mt, j, Be, Ke, de, ct, Pe, Ot, Z, Je = !1, Vt = !1, Ht = [], Ve, ye, nn, on, no, oo, it, Ge, dt, ft = !1, St = !1, Pt, te, rn = [], mn = !1, Wt = [], qt = typeof document < "u", At = wo, io = wt || Ie ? "cssFloat" : "float", xi = qt && !gi && !wo && "draggable" in document.createElement("div"), xo = function() {
  if (qt) {
    if (Ie)
      return !1;
    var t = document.createElement("x");
    return t.style.cssText = "pointer-events:auto", t.style.pointerEvents === "auto";
  }
}(), Oo = function(e, n) {
  var o = $(e), i = parseInt(o.width) - parseInt(o.paddingLeft) - parseInt(o.paddingRight) - parseInt(o.borderLeftWidth) - parseInt(o.borderRightWidth), r = Ze(e, 0, n), a = Ze(e, 1, n), l = r && $(r), s = a && $(a), c = l && parseInt(l.marginLeft) + parseInt(l.marginRight) + G(r).width, d = s && parseInt(s.marginLeft) + parseInt(s.marginRight) + G(a).width;
  if (o.display === "flex")
    return o.flexDirection === "column" || o.flexDirection === "column-reverse" ? "vertical" : "horizontal";
  if (o.display === "grid")
    return o.gridTemplateColumns.split(" ").length <= 1 ? "vertical" : "horizontal";
  if (r && l.float && l.float !== "none") {
    var u = l.float === "left" ? "left" : "right";
    return a && (s.clear === "both" || s.clear === u) ? "vertical" : "horizontal";
  }
  return r && (l.display === "block" || l.display === "flex" || l.display === "table" || l.display === "grid" || c >= i && o[io] === "none" || a && o[io] === "none" && c + d > i) ? "vertical" : "horizontal";
}, Oi = function(e, n, o) {
  var i = o ? e.left : e.top, r = o ? e.right : e.bottom, a = o ? e.width : e.height, l = o ? n.left : n.top, s = o ? n.right : n.bottom, c = o ? n.width : n.height;
  return i === l || r === s || i + a / 2 === l + c / 2;
}, Si = function(e, n) {
  var o;
  return Ht.some(function(i) {
    var r = i[pe].options.emptyInsertThreshold;
    if (!(!r || Sn(i))) {
      var a = G(i), l = e >= a.left - r && e <= a.right + r, s = n >= a.top - r && n <= a.bottom + r;
      if (l && s)
        return o = i;
    }
  }), o;
}, So = function(e) {
  function n(r, a) {
    return function(l, s, c, d) {
      var u = l.options.group.name && s.options.group.name && l.options.group.name === s.options.group.name;
      if (r == null && (a || u))
        return !0;
      if (r == null || r === !1)
        return !1;
      if (a && r === "clone")
        return r;
      if (typeof r == "function")
        return n(r(l, s, c, d), a)(l, s, c, d);
      var y = (a ? l : s).options.group.name;
      return r === !0 || typeof r == "string" && r === y || r.join && r.indexOf(y) > -1;
    };
  }
  var o = {}, i = e.group;
  (!i || It(i) != "object") && (i = {
    name: i
  }), o.name = i.name, o.checkPull = n(i.pull, !0), o.checkPut = n(i.put), o.revertClone = i.revertClone, e.group = o;
}, Ao = function() {
  !xo && I && $(I, "display", "none");
}, ko = function() {
  !xo && I && $(I, "display", "");
};
qt && document.addEventListener("click", function(t) {
  if (Vt)
    return t.preventDefault(), t.stopPropagation && t.stopPropagation(), t.stopImmediatePropagation && t.stopImmediatePropagation(), Vt = !1, !1;
}, !0);
var He = function(e) {
  if (_) {
    e = e.touches ? e.touches[0] : e;
    var n = Si(e.clientX, e.clientY);
    if (n) {
      var o = {};
      for (var i in e)
        e.hasOwnProperty(i) && (o[i] = e[i]);
      o.target = o.rootEl = n, o.preventDefault = void 0, o.stopPropagation = void 0, n[pe]._onDragOver(o);
    }
  }
}, Ai = function(e) {
  _ && _.parentNode[pe]._isOutsideThisEl(e.target);
};
function L(t, e) {
  if (!(t && t.nodeType && t.nodeType === 1))
    throw "Sortable: `el` must be an HTMLElement, not ".concat({}.toString.call(t));
  this.el = t, this.options = e = $e({}, e), t[pe] = this;
  var n = {
    group: null,
    sort: !0,
    disabled: !1,
    store: null,
    handle: null,
    draggable: /^[uo]l$/i.test(t.nodeName) ? ">li" : ">*",
    swapThreshold: 1,
    // percentage; 0 <= x <= 1
    invertSwap: !1,
    // invert always
    invertedSwapThreshold: null,
    // will be set to same as swapThreshold if default
    removeCloneOnHide: !0,
    direction: function() {
      return Oo(t, this.options);
    },
    ghostClass: "sortable-ghost",
    chosenClass: "sortable-chosen",
    dragClass: "sortable-drag",
    ignore: "a, img",
    filter: null,
    preventOnFilter: !0,
    animation: 0,
    easing: null,
    setData: function(a, l) {
      a.setData("Text", l.textContent);
    },
    dropBubble: !1,
    dragoverBubble: !1,
    dataIdAttr: "data-id",
    delay: 0,
    delayOnTouchOnly: !1,
    touchStartThreshold: (Number.parseInt ? Number : window).parseInt(window.devicePixelRatio, 10) || 1,
    forceFallback: !1,
    fallbackClass: "sortable-fallback",
    fallbackOnBody: !1,
    fallbackTolerance: 0,
    fallbackOffset: {
      x: 0,
      y: 0
    },
    supportPointer: L.supportPointer !== !1 && "PointerEvent" in window && !st,
    emptyInsertThreshold: 5
  };
  _t.initializePlugins(this, t, n);
  for (var o in n)
    !(o in e) && (e[o] = n[o]);
  So(e);
  for (var i in this)
    i.charAt(0) === "_" && typeof this[i] == "function" && (this[i] = this[i].bind(this));
  this.nativeDraggable = e.forceFallback ? !1 : xi, this.nativeDraggable && (this.options.touchStartThreshold = 1), e.supportPointer ? N(t, "pointerdown", this._onTapStart) : (N(t, "mousedown", this._onTapStart), N(t, "touchstart", this._onTapStart)), this.nativeDraggable && (N(t, "dragover", this), N(t, "dragenter", this)), Ht.push(this.el), e.store && e.store.get && this.sort(e.store.get(this) || []), $e(this, _i());
}
L.prototype = /** @lends Sortable.prototype */
{
  constructor: L,
  _isOutsideThisEl: function(e) {
    !this.el.contains(e) && e !== this.el && (Ge = null);
  },
  _getDirection: function(e, n) {
    return typeof this.options.direction == "function" ? this.options.direction.call(this, e, n, _) : this.options.direction;
  },
  _onTapStart: function(e) {
    if (e.cancelable) {
      var n = this, o = this.el, i = this.options, r = i.preventOnFilter, a = e.type, l = e.touches && e.touches[0] || e.pointerType && e.pointerType === "touch" && e, s = (l || e).target, c = e.target.shadowRoot && (e.path && e.path[0] || e.composedPath && e.composedPath()[0]) || s, d = i.filter;
      if (Bi(o), !_ && !(/mousedown|pointerdown/.test(a) && e.button !== 0 || i.disabled) && !c.isContentEditable && !(!this.nativeDraggable && st && s && s.tagName.toUpperCase() === "SELECT") && (s = Ee(s, i.draggable, o, !1), !(s && s.animated) && Mt !== s)) {
        if (Ke = he(s), ct = he(s, i.draggable), typeof d == "function") {
          if (d.call(this, e, s, this)) {
            ae({
              sortable: n,
              rootEl: c,
              name: "filter",
              targetEl: s,
              toEl: o,
              fromEl: o
            }), se("filter", n, {
              evt: e
            }), r && e.cancelable && e.preventDefault();
            return;
          }
        } else if (d && (d = d.split(",").some(function(u) {
          if (u = Ee(c, u.trim(), o, !1), u)
            return ae({
              sortable: n,
              rootEl: u,
              name: "filter",
              targetEl: s,
              fromEl: o,
              toEl: o
            }), se("filter", n, {
              evt: e
            }), !0;
        }), d)) {
          r && e.cancelable && e.preventDefault();
          return;
        }
        i.handle && !Ee(c, i.handle, o, !1) || this._prepareDragStart(e, l, s);
      }
    }
  },
  _prepareDragStart: function(e, n, o) {
    var i = this, r = i.el, a = i.options, l = r.ownerDocument, s;
    if (o && !_ && o.parentNode === r) {
      var c = G(o);
      if (R = r, _ = o, Y = _.parentNode, We = _.nextSibling, Mt = o, Ot = a.group, L.dragged = _, Ve = {
        target: _,
        clientX: (n || e).clientX,
        clientY: (n || e).clientY
      }, no = Ve.clientX - c.left, oo = Ve.clientY - c.top, this._lastX = (n || e).clientX, this._lastY = (n || e).clientY, _.style["will-change"] = "all", s = function() {
        if (se("delayEnded", i, {
          evt: e
        }), L.eventCanceled) {
          i._onDrop();
          return;
        }
        i._disableDelayedDragEvents(), !Qn && i.nativeDraggable && (_.draggable = !0), i._triggerDragStart(e, n), ae({
          sortable: i,
          name: "choose",
          originalEvent: e
        }), ce(_, a.chosenClass, !0);
      }, a.ignore.split(",").forEach(function(d) {
        To(_, d.trim(), an);
      }), N(l, "dragover", He), N(l, "mousemove", He), N(l, "touchmove", He), N(l, "mouseup", i._onDrop), N(l, "touchend", i._onDrop), N(l, "touchcancel", i._onDrop), Qn && this.nativeDraggable && (this.options.touchStartThreshold = 4, _.draggable = !0), se("delayStart", this, {
        evt: e
      }), a.delay && (!a.delayOnTouchOnly || n) && (!this.nativeDraggable || !(wt || Ie))) {
        if (L.eventCanceled) {
          this._onDrop();
          return;
        }
        N(l, "mouseup", i._disableDelayedDrag), N(l, "touchend", i._disableDelayedDrag), N(l, "touchcancel", i._disableDelayedDrag), N(l, "mousemove", i._delayedDragTouchMoveHandler), N(l, "touchmove", i._delayedDragTouchMoveHandler), a.supportPointer && N(l, "pointermove", i._delayedDragTouchMoveHandler), i._dragStartTimer = setTimeout(s, a.delay);
      } else
        s();
    }
  },
  _delayedDragTouchMoveHandler: function(e) {
    var n = e.touches ? e.touches[0] : e;
    Math.max(Math.abs(n.clientX - this._lastX), Math.abs(n.clientY - this._lastY)) >= Math.floor(this.options.touchStartThreshold / (this.nativeDraggable && window.devicePixelRatio || 1)) && this._disableDelayedDrag();
  },
  _disableDelayedDrag: function() {
    _ && an(_), clearTimeout(this._dragStartTimer), this._disableDelayedDragEvents();
  },
  _disableDelayedDragEvents: function() {
    var e = this.el.ownerDocument;
    B(e, "mouseup", this._disableDelayedDrag), B(e, "touchend", this._disableDelayedDrag), B(e, "touchcancel", this._disableDelayedDrag), B(e, "mousemove", this._delayedDragTouchMoveHandler), B(e, "touchmove", this._delayedDragTouchMoveHandler), B(e, "pointermove", this._delayedDragTouchMoveHandler);
  },
  _triggerDragStart: function(e, n) {
    n = n || e.pointerType == "touch" && e, !this.nativeDraggable || n ? this.options.supportPointer ? N(document, "pointermove", this._onTouchMove) : n ? N(document, "touchmove", this._onTouchMove) : N(document, "mousemove", this._onTouchMove) : (N(_, "dragend", this), N(R, "dragstart", this._onDragStart));
    try {
      document.selection ? Bt(function() {
        document.selection.empty();
      }) : window.getSelection().removeAllRanges();
    } catch {
    }
  },
  _dragStarted: function(e, n) {
    if (Je = !1, R && _) {
      se("dragStarted", this, {
        evt: n
      }), this.nativeDraggable && N(document, "dragover", Ai);
      var o = this.options;
      !e && ce(_, o.dragClass, !1), ce(_, o.ghostClass, !0), L.active = this, e && this._appendGhost(), ae({
        sortable: this,
        name: "start",
        originalEvent: n
      });
    } else
      this._nulling();
  },
  _emulateDragOver: function() {
    if (ye) {
      this._lastX = ye.clientX, this._lastY = ye.clientY, Ao();
      for (var e = document.elementFromPoint(ye.clientX, ye.clientY), n = e; e && e.shadowRoot && (e = e.shadowRoot.elementFromPoint(ye.clientX, ye.clientY), e !== n); )
        n = e;
      if (_.parentNode[pe]._isOutsideThisEl(e), n)
        do {
          if (n[pe]) {
            var o = void 0;
            if (o = n[pe]._onDragOver({
              clientX: ye.clientX,
              clientY: ye.clientY,
              target: e,
              rootEl: n
            }), o && !this.options.dragoverBubble)
              break;
          }
          e = n;
        } while (n = n.parentNode);
      ko();
    }
  },
  _onTouchMove: function(e) {
    if (Ve) {
      var n = this.options, o = n.fallbackTolerance, i = n.fallbackOffset, r = e.touches ? e.touches[0] : e, a = I && Qe(I, !0), l = I && a && a.a, s = I && a && a.d, c = At && te && to(te), d = (r.clientX - Ve.clientX + i.x) / (l || 1) + (c ? c[0] - rn[0] : 0) / (l || 1), u = (r.clientY - Ve.clientY + i.y) / (s || 1) + (c ? c[1] - rn[1] : 0) / (s || 1);
      if (!L.active && !Je) {
        if (o && Math.max(Math.abs(r.clientX - this._lastX), Math.abs(r.clientY - this._lastY)) < o)
          return;
        this._onDragStart(e, !0);
      }
      if (I) {
        a ? (a.e += d - (nn || 0), a.f += u - (on || 0)) : a = {
          a: 1,
          b: 0,
          c: 0,
          d: 1,
          e: d,
          f: u
        };
        var y = "matrix(".concat(a.a, ",").concat(a.b, ",").concat(a.c, ",").concat(a.d, ",").concat(a.e, ",").concat(a.f, ")");
        $(I, "webkitTransform", y), $(I, "mozTransform", y), $(I, "msTransform", y), $(I, "transform", y), nn = d, on = u, ye = r;
      }
      e.cancelable && e.preventDefault();
    }
  },
  _appendGhost: function() {
    if (!I) {
      var e = this.options.fallbackOnBody ? document.body : R, n = G(_, !0, At, !0, e), o = this.options;
      if (At) {
        for (te = e; $(te, "position") === "static" && $(te, "transform") === "none" && te !== document; )
          te = te.parentNode;
        te !== document.body && te !== document.documentElement ? (te === document && (te = xe()), n.top += te.scrollTop, n.left += te.scrollLeft) : te = xe(), rn = to(te);
      }
      I = _.cloneNode(!0), ce(I, o.ghostClass, !1), ce(I, o.fallbackClass, !0), ce(I, o.dragClass, !0), $(I, "transition", ""), $(I, "transform", ""), $(I, "box-sizing", "border-box"), $(I, "margin", 0), $(I, "top", n.top), $(I, "left", n.left), $(I, "width", n.width), $(I, "height", n.height), $(I, "opacity", "0.8"), $(I, "position", At ? "absolute" : "fixed"), $(I, "zIndex", "100000"), $(I, "pointerEvents", "none"), L.ghost = I, e.appendChild(I), $(I, "transform-origin", no / parseInt(I.style.width) * 100 + "% " + oo / parseInt(I.style.height) * 100 + "%");
    }
  },
  _onDragStart: function(e, n) {
    var o = this, i = e.dataTransfer, r = o.options;
    if (se("dragStart", this, {
      evt: e
    }), L.eventCanceled) {
      this._onDrop();
      return;
    }
    se("setupClone", this), L.eventCanceled || (j = Eo(_), j.draggable = !1, j.style["will-change"] = "", this._hideClone(), ce(j, this.options.chosenClass, !1), L.clone = j), o.cloneId = Bt(function() {
      se("clone", o), !L.eventCanceled && (o.options.removeCloneOnHide || R.insertBefore(j, _), o._hideClone(), ae({
        sortable: o,
        name: "clone"
      }));
    }), !n && ce(_, r.dragClass, !0), n ? (Vt = !0, o._loopId = setInterval(o._emulateDragOver, 50)) : (B(document, "mouseup", o._onDrop), B(document, "touchend", o._onDrop), B(document, "touchcancel", o._onDrop), i && (i.effectAllowed = "move", r.setData && r.setData.call(o, i, _)), N(document, "drop", o), $(_, "transform", "translateZ(0)")), Je = !0, o._dragStartId = Bt(o._dragStarted.bind(o, n, e)), N(document, "selectstart", o), it = !0, st && $(document.body, "user-select", "none");
  },
  // Returns true - if no further action is needed (either inserted or another condition)
  _onDragOver: function(e) {
    var n = this.el, o = e.target, i, r, a, l = this.options, s = l.group, c = L.active, d = Ot === s, u = l.sort, y = Z || c, b, p = this, h = !1;
    if (mn)
      return;
    function g(U, J) {
      se(U, p, Se({
        evt: e,
        isOwner: d,
        axis: b ? "vertical" : "horizontal",
        revert: a,
        dragRect: i,
        targetRect: r,
        canSort: u,
        fromSortable: y,
        target: o,
        completed: x,
        onMove: function(ve, Me) {
          return kt(R, n, _, i, ve, G(ve), e, Me);
        },
        changed: w
      }, J));
    }
    function E() {
      g("dragOverAnimationCapture"), p.captureAnimationState(), p !== y && y.captureAnimationState();
    }
    function x(U) {
      return g("dragOverCompleted", {
        insertion: U
      }), U && (d ? c._hideClone() : c._showClone(p), p !== y && (ce(_, Z ? Z.options.ghostClass : c.options.ghostClass, !1), ce(_, l.ghostClass, !0)), Z !== p && p !== L.active ? Z = p : p === L.active && Z && (Z = null), y === p && (p._ignoreWhileAnimating = o), p.animateAll(function() {
        g("dragOverAnimationComplete"), p._ignoreWhileAnimating = null;
      }), p !== y && (y.animateAll(), y._ignoreWhileAnimating = null)), (o === _ && !_.animated || o === n && !o.animated) && (Ge = null), !l.dragoverBubble && !e.rootEl && o !== document && (_.parentNode[pe]._isOutsideThisEl(e.target), !U && He(e)), !l.dragoverBubble && e.stopPropagation && e.stopPropagation(), h = !0;
    }
    function w() {
      de = he(_), Pe = he(_, l.draggable), ae({
        sortable: p,
        name: "change",
        toEl: n,
        newIndex: de,
        newDraggableIndex: Pe,
        originalEvent: e
      });
    }
    if (e.preventDefault !== void 0 && e.cancelable && e.preventDefault(), o = Ee(o, l.draggable, n, !0), g("dragOver"), L.eventCanceled)
      return h;
    if (_.contains(e.target) || o.animated && o.animatingX && o.animatingY || p._ignoreWhileAnimating === o)
      return x(!1);
    if (Vt = !1, c && !l.disabled && (d ? u || (a = Y !== R) : Z === this || (this.lastPutMode = Ot.checkPull(this, c, _, e)) && s.checkPut(this, c, _, e))) {
      if (b = this._getDirection(e, o) === "vertical", i = G(_), g("dragOverValid"), L.eventCanceled)
        return h;
      if (a)
        return Y = R, E(), this._hideClone(), g("revert"), L.eventCanceled || (We ? R.insertBefore(_, We) : R.appendChild(_)), x(!0);
      var C = Sn(n, l.draggable);
      if (!C || Li(e, b, this) && !C.animated) {
        if (C === _)
          return x(!1);
        if (C && n === e.target && (o = C), o && (r = G(o)), kt(R, n, _, i, o, r, e, !!o) !== !1)
          return E(), n.appendChild(_), Y = n, w(), x(!0);
      } else if (C && $i(e, b, this)) {
        var O = Ze(n, 0, l, !0);
        if (O === _)
          return x(!1);
        if (o = O, r = G(o), kt(R, n, _, i, o, r, e, !1) !== !1)
          return E(), n.insertBefore(_, O), Y = n, w(), x(!0);
      } else if (o.parentNode === n) {
        r = G(o);
        var F = 0, m, T = _.parentNode !== n, v = !Oi(_.animated && _.toRect || i, o.animated && o.toRect || r, b), D = b ? "top" : "left", S = eo(o, "top", "top") || eo(_, "top", "top"), V = S ? S.scrollTop : void 0;
        Ge !== o && (m = r[D], ft = !1, St = !v && l.invertSwap || T), F = Ii(e, o, r, b, v ? 1 : l.swapThreshold, l.invertedSwapThreshold == null ? l.swapThreshold : l.invertedSwapThreshold, St, Ge === o);
        var k;
        if (F !== 0) {
          var H = he(_);
          do
            H -= F, k = Y.children[H];
          while (k && ($(k, "display") === "none" || k === I));
        }
        if (F === 0 || k === o)
          return x(!1);
        Ge = o, dt = F;
        var re = o.nextElementSibling, W = !1;
        W = F === 1;
        var le = kt(R, n, _, i, o, r, e, W);
        if (le !== !1)
          return (le === 1 || le === -1) && (W = le === 1), mn = !0, setTimeout(Fi, 30), E(), W && !re ? n.appendChild(_) : o.parentNode.insertBefore(_, W ? re : o), S && Do(S, 0, V - S.scrollTop), Y = _.parentNode, m !== void 0 && !St && (Pt = Math.abs(m - G(o)[D])), w(), x(!0);
      }
      if (n.contains(_))
        return x(!1);
    }
    return !1;
  },
  _ignoreWhileAnimating: null,
  _offMoveEvents: function() {
    B(document, "mousemove", this._onTouchMove), B(document, "touchmove", this._onTouchMove), B(document, "pointermove", this._onTouchMove), B(document, "dragover", He), B(document, "mousemove", He), B(document, "touchmove", He);
  },
  _offUpEvents: function() {
    var e = this.el.ownerDocument;
    B(e, "mouseup", this._onDrop), B(e, "touchend", this._onDrop), B(e, "pointerup", this._onDrop), B(e, "touchcancel", this._onDrop), B(document, "selectstart", this);
  },
  _onDrop: function(e) {
    var n = this.el, o = this.options;
    if (de = he(_), Pe = he(_, o.draggable), se("drop", this, {
      evt: e
    }), Y = _ && _.parentNode, de = he(_), Pe = he(_, o.draggable), L.eventCanceled) {
      this._nulling();
      return;
    }
    Je = !1, St = !1, ft = !1, clearInterval(this._loopId), clearTimeout(this._dragStartTimer), bn(this.cloneId), bn(this._dragStartId), this.nativeDraggable && (B(document, "drop", this), B(n, "dragstart", this._onDragStart)), this._offMoveEvents(), this._offUpEvents(), st && $(document.body, "user-select", ""), $(_, "transform", ""), e && (it && (e.cancelable && e.preventDefault(), !o.dropBubble && e.stopPropagation()), I && I.parentNode && I.parentNode.removeChild(I), (R === Y || Z && Z.lastPutMode !== "clone") && j && j.parentNode && j.parentNode.removeChild(j), _ && (this.nativeDraggable && B(_, "dragend", this), an(_), _.style["will-change"] = "", it && !Je && ce(_, Z ? Z.options.ghostClass : this.options.ghostClass, !1), ce(_, this.options.chosenClass, !1), ae({
      sortable: this,
      name: "unchoose",
      toEl: Y,
      newIndex: null,
      newDraggableIndex: null,
      originalEvent: e
    }), R !== Y ? (de >= 0 && (ae({
      rootEl: Y,
      name: "add",
      toEl: Y,
      fromEl: R,
      originalEvent: e
    }), ae({
      sortable: this,
      name: "remove",
      toEl: Y,
      originalEvent: e
    }), ae({
      rootEl: Y,
      name: "sort",
      toEl: Y,
      fromEl: R,
      originalEvent: e
    }), ae({
      sortable: this,
      name: "sort",
      toEl: Y,
      originalEvent: e
    })), Z && Z.save()) : de !== Ke && de >= 0 && (ae({
      sortable: this,
      name: "update",
      toEl: Y,
      originalEvent: e
    }), ae({
      sortable: this,
      name: "sort",
      toEl: Y,
      originalEvent: e
    })), L.active && ((de == null || de === -1) && (de = Ke, Pe = ct), ae({
      sortable: this,
      name: "end",
      toEl: Y,
      originalEvent: e
    }), this.save()))), this._nulling();
  },
  _nulling: function() {
    se("nulling", this), R = _ = Y = I = We = j = Mt = Be = Ve = ye = it = de = Pe = Ke = ct = Ge = dt = Z = Ot = L.dragged = L.ghost = L.clone = L.active = null, Wt.forEach(function(e) {
      e.checked = !0;
    }), Wt.length = nn = on = 0;
  },
  handleEvent: function(e) {
    switch (e.type) {
      case "drop":
      case "dragend":
        this._onDrop(e);
        break;
      case "dragenter":
      case "dragover":
        _ && (this._onDragOver(e), ki(e));
        break;
      case "selectstart":
        e.preventDefault();
        break;
    }
  },
  /**
   * Serializes the item into an array of string.
   * @returns {String[]}
   */
  toArray: function() {
    for (var e = [], n, o = this.el.children, i = 0, r = o.length, a = this.options; i < r; i++)
      n = o[i], Ee(n, a.draggable, this.el, !1) && e.push(n.getAttribute(a.dataIdAttr) || Pi(n));
    return e;
  },
  /**
   * Sorts the elements according to the array.
   * @param  {String[]}  order  order of the items
   */
  sort: function(e, n) {
    var o = {}, i = this.el;
    this.toArray().forEach(function(r, a) {
      var l = i.children[a];
      Ee(l, this.options.draggable, i, !1) && (o[r] = l);
    }, this), n && this.captureAnimationState(), e.forEach(function(r) {
      o[r] && (i.removeChild(o[r]), i.appendChild(o[r]));
    }), n && this.animateAll();
  },
  /**
   * Save the current sorting
   */
  save: function() {
    var e = this.options.store;
    e && e.set && e.set(this);
  },
  /**
   * For each element in the set, get the first element that matches the selector by testing the element itself and traversing up through its ancestors in the DOM tree.
   * @param   {HTMLElement}  el
   * @param   {String}       [selector]  default: `options.draggable`
   * @returns {HTMLElement|null}
   */
  closest: function(e, n) {
    return Ee(e, n || this.options.draggable, this.el, !1);
  },
  /**
   * Set/get option
   * @param   {string} name
   * @param   {*}      [value]
   * @returns {*}
   */
  option: function(e, n) {
    var o = this.options;
    if (n === void 0)
      return o[e];
    var i = _t.modifyOption(this, e, n);
    typeof i < "u" ? o[e] = i : o[e] = n, e === "group" && So(o);
  },
  /**
   * Destroy
   */
  destroy: function() {
    se("destroy", this);
    var e = this.el;
    e[pe] = null, B(e, "mousedown", this._onTapStart), B(e, "touchstart", this._onTapStart), B(e, "pointerdown", this._onTapStart), this.nativeDraggable && (B(e, "dragover", this), B(e, "dragenter", this)), Array.prototype.forEach.call(e.querySelectorAll("[draggable]"), function(n) {
      n.removeAttribute("draggable");
    }), this._onDrop(), this._disableDelayedDragEvents(), Ht.splice(Ht.indexOf(this.el), 1), this.el = e = null;
  },
  _hideClone: function() {
    if (!Be) {
      if (se("hideClone", this), L.eventCanceled)
        return;
      $(j, "display", "none"), this.options.removeCloneOnHide && j.parentNode && j.parentNode.removeChild(j), Be = !0;
    }
  },
  _showClone: function(e) {
    if (e.lastPutMode !== "clone") {
      this._hideClone();
      return;
    }
    if (Be) {
      if (se("showClone", this), L.eventCanceled)
        return;
      _.parentNode == R && !this.options.group.revertClone ? R.insertBefore(j, _) : We ? R.insertBefore(j, We) : R.appendChild(j), this.options.group.revertClone && this.animate(_, j), $(j, "display", ""), Be = !1;
    }
  }
};
function ki(t) {
  t.dataTransfer && (t.dataTransfer.dropEffect = "move"), t.cancelable && t.preventDefault();
}
function kt(t, e, n, o, i, r, a, l) {
  var s, c = t[pe], d = c.options.onMove, u;
  return window.CustomEvent && !Ie && !wt ? s = new CustomEvent("move", {
    bubbles: !0,
    cancelable: !0
  }) : (s = document.createEvent("Event"), s.initEvent("move", !0, !0)), s.to = e, s.from = t, s.dragged = n, s.draggedRect = o, s.related = i || e, s.relatedRect = r || G(e), s.willInsertAfter = l, s.originalEvent = a, t.dispatchEvent(s), d && (u = d.call(c, s, a)), u;
}
function an(t) {
  t.draggable = !1;
}
function Fi() {
  mn = !1;
}
function $i(t, e, n) {
  var o = G(Ze(n.el, 0, n.options, !0)), i = 10;
  return e ? t.clientX < o.left - i || t.clientY < o.top && t.clientX < o.right : t.clientY < o.top - i || t.clientY < o.bottom && t.clientX < o.left;
}
function Li(t, e, n) {
  var o = G(Sn(n.el, n.options.draggable)), i = 10;
  return e ? t.clientX > o.right + i || t.clientX <= o.right && t.clientY > o.bottom && t.clientX >= o.left : t.clientX > o.right && t.clientY > o.top || t.clientX <= o.right && t.clientY > o.bottom + i;
}
function Ii(t, e, n, o, i, r, a, l) {
  var s = o ? t.clientY : t.clientX, c = o ? n.height : n.width, d = o ? n.top : n.left, u = o ? n.bottom : n.right, y = !1;
  if (!a) {
    if (l && Pt < c * i) {
      if (!ft && (dt === 1 ? s > d + c * r / 2 : s < u - c * r / 2) && (ft = !0), ft)
        y = !0;
      else if (dt === 1 ? s < d + Pt : s > u - Pt)
        return -dt;
    } else if (s > d + c * (1 - i) / 2 && s < u - c * (1 - i) / 2)
      return Mi(e);
  }
  return y = y || a, y && (s < d + c * r / 2 || s > u - c * r / 2) ? s > d + c / 2 ? 1 : -1 : 0;
}
function Mi(t) {
  return he(_) < he(t) ? 1 : -1;
}
function Pi(t) {
  for (var e = t.tagName + t.className + t.src + t.href + t.textContent, n = e.length, o = 0; n--; )
    o += e.charCodeAt(n);
  return o.toString(36);
}
function Bi(t) {
  Wt.length = 0;
  for (var e = t.getElementsByTagName("input"), n = e.length; n--; ) {
    var o = e[n];
    o.checked && Wt.push(o);
  }
}
function Bt(t) {
  return setTimeout(t, 0);
}
function bn(t) {
  return clearTimeout(t);
}
qt && N(document, "touchmove", function(t) {
  (L.active || Je) && t.cancelable && t.preventDefault();
});
L.utils = {
  on: N,
  off: B,
  css: $,
  find: To,
  is: function(e, n) {
    return !!Ee(e, n, e, !1);
  },
  extend: yi,
  throttle: Co,
  closest: Ee,
  toggleClass: ce,
  clone: Eo,
  index: he,
  nextTick: Bt,
  cancelNextTick: bn,
  detectDirection: Oo,
  getChild: Ze
};
L.get = function(t) {
  return t[pe];
};
L.mount = function() {
  for (var t = arguments.length, e = new Array(t), n = 0; n < t; n++)
    e[n] = arguments[n];
  e[0].constructor === Array && (e = e[0]), e.forEach(function(o) {
    if (!o.prototype || !o.prototype.constructor)
      throw "Sortable: Mounted plugin must be a constructor function, not ".concat({}.toString.call(o));
    o.utils && (L.utils = Se(Se({}, L.utils), o.utils)), _t.mount(o);
  });
};
L.create = function(t, e) {
  return new L(t, e);
};
L.version = hi;
var X = [], rt, yn, wn = !1, ln, sn, Ut, at;
function Ni() {
  function t() {
    this.defaults = {
      scroll: !0,
      forceAutoScrollFallback: !1,
      scrollSensitivity: 30,
      scrollSpeed: 10,
      bubbleScroll: !0
    };
    for (var e in this)
      e.charAt(0) === "_" && typeof this[e] == "function" && (this[e] = this[e].bind(this));
  }
  return t.prototype = {
    dragStarted: function(n) {
      var o = n.originalEvent;
      this.sortable.nativeDraggable ? N(document, "dragover", this._handleAutoScroll) : this.options.supportPointer ? N(document, "pointermove", this._handleFallbackAutoScroll) : o.touches ? N(document, "touchmove", this._handleFallbackAutoScroll) : N(document, "mousemove", this._handleFallbackAutoScroll);
    },
    dragOverCompleted: function(n) {
      var o = n.originalEvent;
      !this.options.dragOverBubble && !o.rootEl && this._handleAutoScroll(o);
    },
    drop: function() {
      this.sortable.nativeDraggable ? B(document, "dragover", this._handleAutoScroll) : (B(document, "pointermove", this._handleFallbackAutoScroll), B(document, "touchmove", this._handleFallbackAutoScroll), B(document, "mousemove", this._handleFallbackAutoScroll)), ro(), Nt(), wi();
    },
    nulling: function() {
      Ut = yn = rt = wn = at = ln = sn = null, X.length = 0;
    },
    _handleFallbackAutoScroll: function(n) {
      this._handleAutoScroll(n, !0);
    },
    _handleAutoScroll: function(n, o) {
      var i = this, r = (n.touches ? n.touches[0] : n).clientX, a = (n.touches ? n.touches[0] : n).clientY, l = document.elementFromPoint(r, a);
      if (Ut = n, o || this.options.forceAutoScrollFallback || wt || Ie || st) {
        un(n, this.options, l, o);
        var s = Ne(l, !0);
        wn && (!at || r !== ln || a !== sn) && (at && ro(), at = setInterval(function() {
          var c = Ne(document.elementFromPoint(r, a), !0);
          c !== s && (s = c, Nt()), un(n, i.options, c, o);
        }, 10), ln = r, sn = a);
      } else {
        if (!this.options.bubbleScroll || Ne(l, !0) === xe()) {
          Nt();
          return;
        }
        un(n, this.options, Ne(l, !1), !1);
      }
    }
  }, $e(t, {
    pluginName: "scroll",
    initializeByDefault: !0
  });
}
function Nt() {
  X.forEach(function(t) {
    clearInterval(t.pid);
  }), X = [];
}
function ro() {
  clearInterval(at);
}
var un = Co(function(t, e, n, o) {
  if (e.scroll) {
    var i = (t.touches ? t.touches[0] : t).clientX, r = (t.touches ? t.touches[0] : t).clientY, a = e.scrollSensitivity, l = e.scrollSpeed, s = xe(), c = !1, d;
    yn !== n && (yn = n, Nt(), rt = e.scroll, d = e.scrollFn, rt === !0 && (rt = Ne(n, !0)));
    var u = 0, y = rt;
    do {
      var b = y, p = G(b), h = p.top, g = p.bottom, E = p.left, x = p.right, w = p.width, C = p.height, O = void 0, F = void 0, m = b.scrollWidth, T = b.scrollHeight, v = $(b), D = b.scrollLeft, S = b.scrollTop;
      b === s ? (O = w < m && (v.overflowX === "auto" || v.overflowX === "scroll" || v.overflowX === "visible"), F = C < T && (v.overflowY === "auto" || v.overflowY === "scroll" || v.overflowY === "visible")) : (O = w < m && (v.overflowX === "auto" || v.overflowX === "scroll"), F = C < T && (v.overflowY === "auto" || v.overflowY === "scroll"));
      var V = O && (Math.abs(x - i) <= a && D + w < m) - (Math.abs(E - i) <= a && !!D), k = F && (Math.abs(g - r) <= a && S + C < T) - (Math.abs(h - r) <= a && !!S);
      if (!X[u])
        for (var H = 0; H <= u; H++)
          X[H] || (X[H] = {});
      (X[u].vx != V || X[u].vy != k || X[u].el !== b) && (X[u].el = b, X[u].vx = V, X[u].vy = k, clearInterval(X[u].pid), (V != 0 || k != 0) && (c = !0, X[u].pid = setInterval((function() {
        o && this.layer === 0 && L.active._onTouchMove(Ut);
        var re = X[this.layer].vy ? X[this.layer].vy * l : 0, W = X[this.layer].vx ? X[this.layer].vx * l : 0;
        typeof d == "function" && d.call(L.dragged.parentNode[pe], W, re, t, Ut, X[this.layer].el) !== "continue" || Do(X[this.layer].el, W, re);
      }).bind({
        layer: u
      }), 24))), u++;
    } while (e.bubbleScroll && y !== s && (y = Ne(y, !1)));
    wn = c;
  }
}, 30), Fo = function(e) {
  var n = e.originalEvent, o = e.putSortable, i = e.dragEl, r = e.activeSortable, a = e.dispatchSortableEvent, l = e.hideGhostForTarget, s = e.unhideGhostForTarget;
  if (n) {
    var c = o || r;
    l();
    var d = n.changedTouches && n.changedTouches.length ? n.changedTouches[0] : n, u = document.elementFromPoint(d.clientX, d.clientY);
    s(), c && !c.el.contains(u) && (a("spill"), this.onSpill({
      dragEl: i,
      putSortable: o
    }));
  }
};
function An() {
}
An.prototype = {
  startIndex: null,
  dragStart: function(e) {
    var n = e.oldDraggableIndex;
    this.startIndex = n;
  },
  onSpill: function(e) {
    var n = e.dragEl, o = e.putSortable;
    this.sortable.captureAnimationState(), o && o.captureAnimationState();
    var i = Ze(this.sortable.el, this.startIndex, this.options);
    i ? this.sortable.el.insertBefore(n, i) : this.sortable.el.appendChild(n), this.sortable.animateAll(), o && o.animateAll();
  },
  drop: Fo
};
$e(An, {
  pluginName: "revertOnSpill"
});
function kn() {
}
kn.prototype = {
  onSpill: function(e) {
    var n = e.dragEl, o = e.putSortable, i = o || this.sortable;
    i.captureAnimationState(), n.parentNode && n.parentNode.removeChild(n), i.animateAll();
  },
  drop: Fo
};
$e(kn, {
  pluginName: "removeOnSpill"
});
L.mount(new Ni());
L.mount(kn, An);
function Ri() {
  return typeof window < "u" ? window.console : global.console;
}
const Yi = Ri();
function ji(t) {
  const e = /* @__PURE__ */ Object.create(null);
  return function(o) {
    return e[o] || (e[o] = t(o));
  };
}
const Vi = /-(\w)/g, ao = ji((t) => t.replace(Vi, (e, n) => n ? n.toUpperCase() : ""));
function cn(t) {
  t.parentElement !== null && t.parentElement.removeChild(t);
}
function lo(t, e, n) {
  const o = n === 0 ? t.children[0] : t.children[n - 1].nextSibling;
  t.insertBefore(e, o);
}
function Hi(t, e) {
  return Object.values(t).indexOf(e);
}
function Wi(t, e, n, o) {
  if (!t)
    return [];
  const i = Object.values(t), r = e.length - o;
  return [...e].map((l, s) => s >= r ? i.length : i.indexOf(l));
}
function $o(t, e) {
  this.$nextTick(() => this.$emit(t.toLowerCase(), e));
}
function Ui(t) {
  return (e) => {
    this.realList !== null && this["onDrag" + t](e), $o.call(this, t, e);
  };
}
function zi(t) {
  return ["transition-group", "TransitionGroup"].includes(t);
}
function Xi(t) {
  if (!t || t.length !== 1)
    return !1;
  const [{ type: e }] = t;
  return e ? zi(e.name) : !1;
}
function qi(t, e) {
  return e ? { ...e.props, ...e.attrs } : t;
}
const _n = ["Start", "Add", "Remove", "Update", "End"], Tn = ["Choose", "Unchoose", "Sort", "Filter", "Clone"], Gi = ["Move", ..._n, ...Tn].map((t) => "on" + t);
let dn = null;
const Ji = {
  options: Object,
  list: {
    type: Array,
    required: !1,
    default: null
  },
  noTransitionOnDrag: {
    type: Boolean,
    default: !1
  },
  clone: {
    type: Function,
    default: (t) => t
  },
  tag: {
    type: String,
    default: "div"
  },
  move: {
    type: Function,
    default: null
  },
  componentData: {
    type: Object,
    required: !1,
    default: null
  },
  component: {
    type: String,
    default: null
  },
  modelValue: {
    type: Array,
    required: !1,
    default: null
  }
}, Ki = bt({
  name: "VueDraggableNext",
  inheritAttrs: !1,
  emits: [
    "update:modelValue",
    "move",
    "change",
    ..._n.map((t) => t.toLowerCase()),
    ...Tn.map((t) => t.toLowerCase())
  ],
  props: Ji,
  data() {
    return {
      transitionMode: !1,
      noneFunctionalComponentMode: !1,
      headerOffset: 0,
      footerOffset: 0,
      _sortable: {},
      visibleIndexes: [],
      context: {}
    };
  },
  render() {
    const t = this.$slots.default ? this.$slots.default() : null, e = qi(this.$attrs, this.componentData);
    return t ? (this.transitionMode = Xi(t), Xn(this.getTag(), e, t)) : Xn(this.getTag(), e, []);
  },
  created() {
    this.list !== null && this.modelValue !== null && Yi.error("list props are mutually exclusive! Please set one.");
  },
  mounted() {
    const t = {};
    _n.forEach((i) => {
      t["on" + i] = Ui.call(this, i);
    }), Tn.forEach((i) => {
      t["on" + i] = $o.bind(this, i);
    });
    const e = Object.keys(this.$attrs).reduce((i, r) => (i[ao(r)] = this.$attrs[r], i), {}), n = Object.assign({}, e, t, {
      onMove: (i, r) => this.onDragMove(i, r)
    });
    !("draggable" in n) && (n.draggable = ">*");
    const o = this.$el.nodeType === 1 ? this.$el : this.$el.parentElement;
    this._sortable = new L(o, n), o.__draggable_component__ = this, this.computeIndexes();
  },
  beforeUnmount() {
    try {
      this._sortable !== void 0 && this._sortable.destroy();
    } catch {
    }
  },
  computed: {
    realList() {
      return this.list ? this.list : this.modelValue;
    }
  },
  watch: {
    $attrs: {
      handler(t) {
        this.updateOptions(t);
      },
      deep: !0
    },
    realList() {
      this.computeIndexes();
    }
  },
  methods: {
    getTag() {
      return this.component ? Xo(this.component) : this.tag;
    },
    updateOptions(t) {
      for (var e in t) {
        const n = ao(e);
        Gi.indexOf(n) === -1 && this._sortable.option(n, t[e]);
      }
    },
    getChildrenNodes() {
      return this.$el.children;
    },
    computeIndexes() {
      this.$nextTick(() => {
        this.visibleIndexes = Wi(this.getChildrenNodes(), this.$el.children, this.transitionMode, this.footerOffset);
      });
    },
    getUnderlyingVm(t) {
      const e = Hi(this.getChildrenNodes() || [], t);
      if (e === -1)
        return null;
      const n = this.realList[e];
      return { index: e, element: n };
    },
    emitChanges(t) {
      this.$nextTick(() => {
        this.$emit("change", t);
      });
    },
    alterList(t) {
      if (this.list) {
        t(this.list);
        return;
      }
      const e = [...this.modelValue];
      t(e), this.$emit("update:modelValue", e);
    },
    spliceList() {
      const t = (e) => e.splice(...arguments);
      this.alterList(t);
    },
    updatePosition(t, e) {
      const n = (o) => o.splice(e, 0, o.splice(t, 1)[0]);
      this.alterList(n);
    },
    getVmIndex(t) {
      const e = this.visibleIndexes, n = e.length;
      return t > n - 1 ? n : e[t];
    },
    getComponent() {
      return this.$slots.default ? (
        //@ts-ignore
        this.$slots.default()[0].componentInstance
      ) : null;
    },
    resetTransitionData(t) {
      if (!this.noTransitionOnDrag || !this.transitionMode)
        return;
      var e = this.getChildrenNodes();
      e[t].data = null;
      const n = this.getComponent();
      n.children = [], n.kept = void 0;
    },
    onDragStart(t) {
      this.computeIndexes(), this.context = this.getUnderlyingVm(t.item), this.context && (t.item._underlying_vm_ = this.clone(this.context.element), dn = t.item);
    },
    onDragAdd(t) {
      const e = t.item._underlying_vm_;
      if (e === void 0)
        return;
      cn(t.item);
      const n = this.getVmIndex(t.newIndex);
      this.spliceList(n, 0, e), this.computeIndexes();
      const o = { element: e, newIndex: n };
      this.emitChanges({ added: o });
    },
    onDragRemove(t) {
      if (lo(this.$el, t.item, t.oldIndex), t.pullMode === "clone") {
        cn(t.clone);
        return;
      }
      if (!this.context)
        return;
      const e = this.context.index;
      this.spliceList(e, 1);
      const n = { element: this.context.element, oldIndex: e };
      this.resetTransitionData(e), this.emitChanges({ removed: n });
    },
    onDragUpdate(t) {
      cn(t.item), lo(t.from, t.item, t.oldIndex);
      const e = this.context.index, n = this.getVmIndex(t.newIndex);
      this.updatePosition(e, n);
      const o = { element: this.context.element, oldIndex: e, newIndex: n };
      this.emitChanges({ moved: o });
    },
    updateProperty(t, e) {
      t.hasOwnProperty(e) && (t[e] += this.headerOffset);
    },
    onDragMove(t, e) {
      const n = this.move;
      if (!n || !this.realList)
        return !0;
      const o = this.getRelatedContextFromMoveEvent(t), i = this.context, r = this.computeFutureIndex(o, t);
      Object.assign(i, { futureIndex: r });
      const a = Object.assign({}, t, {
        relatedContext: o,
        draggedContext: i
      });
      return n(a, e);
    },
    onDragEnd() {
      this.computeIndexes(), dn = null;
    },
    getTrargetedComponent(t) {
      return t.__draggable_component__;
    },
    getRelatedContextFromMoveEvent({ to: t, related: e }) {
      const n = this.getTrargetedComponent(t);
      if (!n)
        return { component: n };
      const o = n.realList, i = { list: o, component: n };
      if (t !== e && o && n.getUnderlyingVm) {
        const r = n.getUnderlyingVm(e);
        if (r)
          return Object.assign(r, i);
      }
      return i;
    },
    computeFutureIndex(t, e) {
      const n = [...e.to.children].filter((a) => a.style.display !== "none");
      if (n.length === 0)
        return 0;
      const o = n.indexOf(e.related), i = t.component.getVmIndex(o);
      return n.indexOf(dn) !== -1 || !e.willInsertAfter ? i : i + 1;
    }
  }
});
function Cn(t, e, n) {
  var o, i, r, a, l;
  e == null && (e = 100);
  function s() {
    var d = Date.now() - a;
    d < e && d >= 0 ? o = setTimeout(s, e - d) : (o = null, n || (l = t.apply(r, i), r = i = null));
  }
  var c = function() {
    r = this, i = arguments, a = Date.now();
    var d = n && !o;
    return o || (o = setTimeout(s, e)), d && (l = t.apply(r, i), r = i = null), l;
  };
  return c.clear = function() {
    o && (clearTimeout(o), o = null);
  }, c.flush = function() {
    o && (l = t.apply(r, i), r = i = null, clearTimeout(o), o = null);
  }, c;
}
Cn.debounce = Cn;
var fn = Cn;
function Qi(t, e, n) {
  ei(t) ? vt(t, (o, i) => {
    i == null || i.removeEventListener(e, n), o == null || o.addEventListener(e, n);
  }) : yt(() => {
    t.addEventListener(e, n);
  }), zt(() => {
    var o;
    (o = ee(t)) === null || o === void 0 || o.removeEventListener(e, n);
  });
}
function Zi(t, e) {
  const n = "pointerdown";
  return typeof window > "u" || !window ? void 0 : Qi(window, n, (i) => {
    const r = ee(t);
    r && (r === i.target || i.composedPath().includes(r) || e(i));
  });
}
function er(t, e, n) {
  let o = null;
  const i = ue(!1);
  yt(() => {
    (t.content !== void 0 || n.value) && (i.value = !0), o = new MutationObserver(r), o.observe(e.value, {
      childList: !0,
      subtree: !0
    });
  }), zt(() => o.disconnect()), vt(n, (a) => {
    a ? i.value = !0 : i.value = !1;
  });
  const r = () => {
    t.content ? i.value = !0 : i.value = !1;
  };
  return {
    hasContent: i
  };
}
function et(t, e) {
  var n = t.getBoundingClientRect(), o = 1, i = 1;
  return {
    width: n.width / o,
    height: n.height / i,
    top: n.top / i,
    right: n.right / o,
    bottom: n.bottom / i,
    left: n.left / o,
    x: n.left / o,
    y: n.top / i
  };
}
function Ce(t) {
  if (t == null)
    return window;
  if (t.toString() !== "[object Window]") {
    var e = t.ownerDocument;
    return e && e.defaultView || window;
  }
  return t;
}
function Fn(t) {
  var e = Ce(t), n = e.pageXOffset, o = e.pageYOffset;
  return {
    scrollLeft: n,
    scrollTop: o
  };
}
function ht(t) {
  var e = Ce(t).Element;
  return t instanceof e || t instanceof Element;
}
function ge(t) {
  var e = Ce(t).HTMLElement;
  return t instanceof e || t instanceof HTMLElement;
}
function Lo(t) {
  if (typeof ShadowRoot > "u")
    return !1;
  var e = Ce(t).ShadowRoot;
  return t instanceof e || t instanceof ShadowRoot;
}
function tr(t) {
  return {
    scrollLeft: t.scrollLeft,
    scrollTop: t.scrollTop
  };
}
function nr(t) {
  return t === Ce(t) || !ge(t) ? Fn(t) : tr(t);
}
function Ae(t) {
  return t ? (t.nodeName || "").toLowerCase() : null;
}
function Ye(t) {
  return ((ht(t) ? t.ownerDocument : (
    // $FlowFixMe[prop-missing]
    t.document
  )) || window.document).documentElement;
}
function $n(t) {
  return et(Ye(t)).left + Fn(t).scrollLeft;
}
function Le(t) {
  return Ce(t).getComputedStyle(t);
}
function Ln(t) {
  var e = Le(t), n = e.overflow, o = e.overflowX, i = e.overflowY;
  return /auto|scroll|overlay|hidden/.test(n + i + o);
}
function or(t) {
  var e = t.getBoundingClientRect(), n = e.width / t.offsetWidth || 1, o = e.height / t.offsetHeight || 1;
  return n !== 1 || o !== 1;
}
function ir(t, e, n) {
  n === void 0 && (n = !1);
  var o = ge(e);
  ge(e) && or(e);
  var i = Ye(e), r = et(t), a = {
    scrollLeft: 0,
    scrollTop: 0
  }, l = {
    x: 0,
    y: 0
  };
  return (o || !o && !n) && ((Ae(e) !== "body" || // https://github.com/popperjs/popper-core/issues/1078
  Ln(i)) && (a = nr(e)), ge(e) ? (l = et(e), l.x += e.clientLeft, l.y += e.clientTop) : i && (l.x = $n(i))), {
    x: r.left + a.scrollLeft - l.x,
    y: r.top + a.scrollTop - l.y,
    width: r.width,
    height: r.height
  };
}
function In(t) {
  var e = et(t), n = t.offsetWidth, o = t.offsetHeight;
  return Math.abs(e.width - n) <= 1 && (n = e.width), Math.abs(e.height - o) <= 1 && (o = e.height), {
    x: t.offsetLeft,
    y: t.offsetTop,
    width: n,
    height: o
  };
}
function Gt(t) {
  return Ae(t) === "html" ? t : (
    // this is a quicker (but less type safe) way to save quite some bytes from the bundle
    // $FlowFixMe[incompatible-return]
    // $FlowFixMe[prop-missing]
    t.assignedSlot || // step into the shadow DOM of the parent of a slotted node
    t.parentNode || // DOM Element detected
    (Lo(t) ? t.host : null) || // ShadowRoot detected
    // $FlowFixMe[incompatible-call]: HTMLElement is a Node
    Ye(t)
  );
}
function Io(t) {
  return ["html", "body", "#document"].indexOf(Ae(t)) >= 0 ? t.ownerDocument.body : ge(t) && Ln(t) ? t : Io(Gt(t));
}
function pt(t, e) {
  var n;
  e === void 0 && (e = []);
  var o = Io(t), i = o === ((n = t.ownerDocument) == null ? void 0 : n.body), r = Ce(o), a = i ? [r].concat(r.visualViewport || [], Ln(o) ? o : []) : o, l = e.concat(a);
  return i ? l : (
    // $FlowFixMe[incompatible-call]: isBody tells us target will be an HTMLElement here
    l.concat(pt(Gt(a)))
  );
}
function rr(t) {
  return ["table", "td", "th"].indexOf(Ae(t)) >= 0;
}
function so(t) {
  return !ge(t) || // https://github.com/popperjs/popper-core/issues/837
  Le(t).position === "fixed" ? null : t.offsetParent;
}
function ar(t) {
  var e = navigator.userAgent.toLowerCase().indexOf("firefox") !== -1, n = navigator.userAgent.indexOf("Trident") !== -1;
  if (n && ge(t)) {
    var o = Le(t);
    if (o.position === "fixed")
      return null;
  }
  for (var i = Gt(t); ge(i) && ["html", "body"].indexOf(Ae(i)) < 0; ) {
    var r = Le(i);
    if (r.transform !== "none" || r.perspective !== "none" || r.contain === "paint" || ["transform", "perspective"].indexOf(r.willChange) !== -1 || e && r.willChange === "filter" || e && r.filter && r.filter !== "none")
      return i;
    i = i.parentNode;
  }
  return null;
}
function Tt(t) {
  for (var e = Ce(t), n = so(t); n && rr(n) && Le(n).position === "static"; )
    n = so(n);
  return n && (Ae(n) === "html" || Ae(n) === "body" && Le(n).position === "static") ? e : n || ar(t) || e;
}
var me = "top", _e = "bottom", Te = "right", be = "left", Mn = "auto", Ct = [me, _e, Te, be], tt = "start", gt = "end", lr = "clippingParents", Mo = "viewport", ot = "popper", sr = "reference", uo = /* @__PURE__ */ Ct.reduce(function(t, e) {
  return t.concat([e + "-" + tt, e + "-" + gt]);
}, []), Po = /* @__PURE__ */ [].concat(Ct, [Mn]).reduce(function(t, e) {
  return t.concat([e, e + "-" + tt, e + "-" + gt]);
}, []), ur = "beforeRead", cr = "read", dr = "afterRead", fr = "beforeMain", pr = "main", vr = "afterMain", hr = "beforeWrite", gr = "write", mr = "afterWrite", br = [ur, cr, dr, fr, pr, vr, hr, gr, mr];
function yr(t) {
  var e = /* @__PURE__ */ new Map(), n = /* @__PURE__ */ new Set(), o = [];
  t.forEach(function(r) {
    e.set(r.name, r);
  });
  function i(r) {
    n.add(r.name);
    var a = [].concat(r.requires || [], r.requiresIfExists || []);
    a.forEach(function(l) {
      if (!n.has(l)) {
        var s = e.get(l);
        s && i(s);
      }
    }), o.push(r);
  }
  return t.forEach(function(r) {
    n.has(r.name) || i(r);
  }), o;
}
function wr(t) {
  var e = yr(t);
  return br.reduce(function(n, o) {
    return n.concat(e.filter(function(i) {
      return i.phase === o;
    }));
  }, []);
}
function _r(t) {
  var e;
  return function() {
    return e || (e = new Promise(function(n) {
      Promise.resolve().then(function() {
        e = void 0, n(t());
      });
    })), e;
  };
}
function Oe(t) {
  return t.split("-")[0];
}
function Tr(t) {
  var e = t.reduce(function(n, o) {
    var i = n[o.name];
    return n[o.name] = i ? Object.assign({}, i, o, {
      options: Object.assign({}, i.options, o.options),
      data: Object.assign({}, i.data, o.data)
    }) : o, n;
  }, {});
  return Object.keys(e).map(function(n) {
    return e[n];
  });
}
function Cr(t) {
  var e = Ce(t), n = Ye(t), o = e.visualViewport, i = n.clientWidth, r = n.clientHeight, a = 0, l = 0;
  return o && (i = o.width, r = o.height, /^((?!chrome|android).)*safari/i.test(navigator.userAgent) || (a = o.offsetLeft, l = o.offsetTop)), {
    width: i,
    height: r,
    x: a + $n(t),
    y: l
  };
}
var Re = Math.max, mt = Math.min, Ft = Math.round;
function Dr(t) {
  var e, n = Ye(t), o = Fn(t), i = (e = t.ownerDocument) == null ? void 0 : e.body, r = Re(n.scrollWidth, n.clientWidth, i ? i.scrollWidth : 0, i ? i.clientWidth : 0), a = Re(n.scrollHeight, n.clientHeight, i ? i.scrollHeight : 0, i ? i.clientHeight : 0), l = -o.scrollLeft + $n(t), s = -o.scrollTop;
  return Le(i || n).direction === "rtl" && (l += Re(n.clientWidth, i ? i.clientWidth : 0) - r), {
    width: r,
    height: a,
    x: l,
    y: s
  };
}
function Bo(t, e) {
  var n = e.getRootNode && e.getRootNode();
  if (t.contains(e))
    return !0;
  if (n && Lo(n)) {
    var o = e;
    do {
      if (o && t.isSameNode(o))
        return !0;
      o = o.parentNode || o.host;
    } while (o);
  }
  return !1;
}
function Dn(t) {
  return Object.assign({}, t, {
    left: t.x,
    top: t.y,
    right: t.x + t.width,
    bottom: t.y + t.height
  });
}
function Er(t) {
  var e = et(t);
  return e.top = e.top + t.clientTop, e.left = e.left + t.clientLeft, e.bottom = e.top + t.clientHeight, e.right = e.left + t.clientWidth, e.width = t.clientWidth, e.height = t.clientHeight, e.x = e.left, e.y = e.top, e;
}
function co(t, e) {
  return e === Mo ? Dn(Cr(t)) : ge(e) ? Er(e) : Dn(Dr(Ye(t)));
}
function xr(t) {
  var e = pt(Gt(t)), n = ["absolute", "fixed"].indexOf(Le(t).position) >= 0, o = n && ge(t) ? Tt(t) : t;
  return ht(o) ? e.filter(function(i) {
    return ht(i) && Bo(i, o) && Ae(i) !== "body";
  }) : [];
}
function Or(t, e, n) {
  var o = e === "clippingParents" ? xr(t) : [].concat(e), i = [].concat(o, [n]), r = i[0], a = i.reduce(function(l, s) {
    var c = co(t, s);
    return l.top = Re(c.top, l.top), l.right = mt(c.right, l.right), l.bottom = mt(c.bottom, l.bottom), l.left = Re(c.left, l.left), l;
  }, co(t, r));
  return a.width = a.right - a.left, a.height = a.bottom - a.top, a.x = a.left, a.y = a.top, a;
}
function nt(t) {
  return t.split("-")[1];
}
function Pn(t) {
  return ["top", "bottom"].indexOf(t) >= 0 ? "x" : "y";
}
function No(t) {
  var e = t.reference, n = t.element, o = t.placement, i = o ? Oe(o) : null, r = o ? nt(o) : null, a = e.x + e.width / 2 - n.width / 2, l = e.y + e.height / 2 - n.height / 2, s;
  switch (i) {
    case me:
      s = {
        x: a,
        y: e.y - n.height
      };
      break;
    case _e:
      s = {
        x: a,
        y: e.y + e.height
      };
      break;
    case Te:
      s = {
        x: e.x + e.width,
        y: l
      };
      break;
    case be:
      s = {
        x: e.x - n.width,
        y: l
      };
      break;
    default:
      s = {
        x: e.x,
        y: e.y
      };
  }
  var c = i ? Pn(i) : null;
  if (c != null) {
    var d = c === "y" ? "height" : "width";
    switch (r) {
      case tt:
        s[c] = s[c] - (e[d] / 2 - n[d] / 2);
        break;
      case gt:
        s[c] = s[c] + (e[d] / 2 - n[d] / 2);
        break;
    }
  }
  return s;
}
function Ro() {
  return {
    top: 0,
    right: 0,
    bottom: 0,
    left: 0
  };
}
function Yo(t) {
  return Object.assign({}, Ro(), t);
}
function jo(t, e) {
  return e.reduce(function(n, o) {
    return n[o] = t, n;
  }, {});
}
function Bn(t, e) {
  e === void 0 && (e = {});
  var n = e, o = n.placement, i = o === void 0 ? t.placement : o, r = n.boundary, a = r === void 0 ? lr : r, l = n.rootBoundary, s = l === void 0 ? Mo : l, c = n.elementContext, d = c === void 0 ? ot : c, u = n.altBoundary, y = u === void 0 ? !1 : u, b = n.padding, p = b === void 0 ? 0 : b, h = Yo(typeof p != "number" ? p : jo(p, Ct)), g = d === ot ? sr : ot, E = t.rects.popper, x = t.elements[y ? g : d], w = Or(ht(x) ? x : x.contextElement || Ye(t.elements.popper), a, s), C = et(t.elements.reference), O = No({
    reference: C,
    element: E,
    strategy: "absolute",
    placement: i
  }), F = Dn(Object.assign({}, E, O)), m = d === ot ? F : C, T = {
    top: w.top - m.top + h.top,
    bottom: m.bottom - w.bottom + h.bottom,
    left: w.left - m.left + h.left,
    right: m.right - w.right + h.right
  }, v = t.modifiersData.offset;
  if (d === ot && v) {
    var D = v[i];
    Object.keys(T).forEach(function(S) {
      var V = [Te, _e].indexOf(S) >= 0 ? 1 : -1, k = [me, _e].indexOf(S) >= 0 ? "y" : "x";
      T[S] += D[k] * V;
    });
  }
  return T;
}
var fo = {
  placement: "bottom",
  modifiers: [],
  strategy: "absolute"
};
function po() {
  for (var t = arguments.length, e = new Array(t), n = 0; n < t; n++)
    e[n] = arguments[n];
  return !e.some(function(o) {
    return !(o && typeof o.getBoundingClientRect == "function");
  });
}
function Sr(t) {
  t === void 0 && (t = {});
  var e = t, n = e.defaultModifiers, o = n === void 0 ? [] : n, i = e.defaultOptions, r = i === void 0 ? fo : i;
  return function(l, s, c) {
    c === void 0 && (c = r);
    var d = {
      placement: "bottom",
      orderedModifiers: [],
      options: Object.assign({}, fo, r),
      modifiersData: {},
      elements: {
        reference: l,
        popper: s
      },
      attributes: {},
      styles: {}
    }, u = [], y = !1, b = {
      state: d,
      setOptions: function(E) {
        var x = typeof E == "function" ? E(d.options) : E;
        h(), d.options = Object.assign({}, r, d.options, x), d.scrollParents = {
          reference: ht(l) ? pt(l) : l.contextElement ? pt(l.contextElement) : [],
          popper: pt(s)
        };
        var w = wr(Tr([].concat(o, d.options.modifiers)));
        return d.orderedModifiers = w.filter(function(C) {
          return C.enabled;
        }), p(), b.update();
      },
      // Sync update – it will always be executed, even if not necessary. This
      // is useful for low frequency updates where sync behavior simplifies the
      // logic.
      // For high frequency updates (e.g. `resize` and `scroll` events), always
      // prefer the async Popper#update method
      forceUpdate: function() {
        if (!y) {
          var E = d.elements, x = E.reference, w = E.popper;
          if (po(x, w)) {
            d.rects = {
              reference: ir(x, Tt(w), d.options.strategy === "fixed"),
              popper: In(w)
            }, d.reset = !1, d.placement = d.options.placement, d.orderedModifiers.forEach(function(D) {
              return d.modifiersData[D.name] = Object.assign({}, D.data);
            });
            for (var C = 0; C < d.orderedModifiers.length; C++) {
              if (d.reset === !0) {
                d.reset = !1, C = -1;
                continue;
              }
              var O = d.orderedModifiers[C], F = O.fn, m = O.options, T = m === void 0 ? {} : m, v = O.name;
              typeof F == "function" && (d = F({
                state: d,
                options: T,
                name: v,
                instance: b
              }) || d);
            }
          }
        }
      },
      // Async and optimistically optimized update – it will not be executed if
      // not necessary (debounced to run at most once-per-tick)
      update: _r(function() {
        return new Promise(function(g) {
          b.forceUpdate(), g(d);
        });
      }),
      destroy: function() {
        h(), y = !0;
      }
    };
    if (!po(l, s))
      return b;
    b.setOptions(c).then(function(g) {
      !y && c.onFirstUpdate && c.onFirstUpdate(g);
    });
    function p() {
      d.orderedModifiers.forEach(function(g) {
        var E = g.name, x = g.options, w = x === void 0 ? {} : x, C = g.effect;
        if (typeof C == "function") {
          var O = C({
            state: d,
            name: E,
            instance: b,
            options: w
          }), F = function() {
          };
          u.push(O || F);
        }
      });
    }
    function h() {
      u.forEach(function(g) {
        return g();
      }), u = [];
    }
    return b;
  };
}
var $t = {
  passive: !0
};
function Ar(t) {
  var e = t.state, n = t.instance, o = t.options, i = o.scroll, r = i === void 0 ? !0 : i, a = o.resize, l = a === void 0 ? !0 : a, s = Ce(e.elements.popper), c = [].concat(e.scrollParents.reference, e.scrollParents.popper);
  return r && c.forEach(function(d) {
    d.addEventListener("scroll", n.update, $t);
  }), l && s.addEventListener("resize", n.update, $t), function() {
    r && c.forEach(function(d) {
      d.removeEventListener("scroll", n.update, $t);
    }), l && s.removeEventListener("resize", n.update, $t);
  };
}
var kr = {
  name: "eventListeners",
  enabled: !0,
  phase: "write",
  fn: function() {
  },
  effect: Ar,
  data: {}
};
function Fr(t) {
  var e = t.state, n = t.name;
  e.modifiersData[n] = No({
    reference: e.rects.reference,
    element: e.rects.popper,
    strategy: "absolute",
    placement: e.placement
  });
}
var $r = {
  name: "popperOffsets",
  enabled: !0,
  phase: "read",
  fn: Fr,
  data: {}
}, Lr = {
  top: "auto",
  right: "auto",
  bottom: "auto",
  left: "auto"
};
function Ir(t) {
  var e = t.x, n = t.y, o = window, i = o.devicePixelRatio || 1;
  return {
    x: Ft(Ft(e * i) / i) || 0,
    y: Ft(Ft(n * i) / i) || 0
  };
}
function vo(t) {
  var e, n = t.popper, o = t.popperRect, i = t.placement, r = t.variation, a = t.offsets, l = t.position, s = t.gpuAcceleration, c = t.adaptive, d = t.roundOffsets, u = d === !0 ? Ir(a) : typeof d == "function" ? d(a) : a, y = u.x, b = y === void 0 ? 0 : y, p = u.y, h = p === void 0 ? 0 : p, g = a.hasOwnProperty("x"), E = a.hasOwnProperty("y"), x = be, w = me, C = window;
  if (c) {
    var O = Tt(n), F = "clientHeight", m = "clientWidth";
    O === Ce(n) && (O = Ye(n), Le(O).position !== "static" && l === "absolute" && (F = "scrollHeight", m = "scrollWidth")), O = O, (i === me || (i === be || i === Te) && r === gt) && (w = _e, h -= O[F] - o.height, h *= s ? 1 : -1), (i === be || (i === me || i === _e) && r === gt) && (x = Te, b -= O[m] - o.width, b *= s ? 1 : -1);
  }
  var T = Object.assign({
    position: l
  }, c && Lr);
  if (s) {
    var v;
    return Object.assign({}, T, (v = {}, v[w] = E ? "0" : "", v[x] = g ? "0" : "", v.transform = (C.devicePixelRatio || 1) <= 1 ? "translate(" + b + "px, " + h + "px)" : "translate3d(" + b + "px, " + h + "px, 0)", v));
  }
  return Object.assign({}, T, (e = {}, e[w] = E ? h + "px" : "", e[x] = g ? b + "px" : "", e.transform = "", e));
}
function Mr(t) {
  var e = t.state, n = t.options, o = n.gpuAcceleration, i = o === void 0 ? !0 : o, r = n.adaptive, a = r === void 0 ? !0 : r, l = n.roundOffsets, s = l === void 0 ? !0 : l, c = {
    placement: Oe(e.placement),
    variation: nt(e.placement),
    popper: e.elements.popper,
    popperRect: e.rects.popper,
    gpuAcceleration: i
  };
  e.modifiersData.popperOffsets != null && (e.styles.popper = Object.assign({}, e.styles.popper, vo(Object.assign({}, c, {
    offsets: e.modifiersData.popperOffsets,
    position: e.options.strategy,
    adaptive: a,
    roundOffsets: s
  })))), e.modifiersData.arrow != null && (e.styles.arrow = Object.assign({}, e.styles.arrow, vo(Object.assign({}, c, {
    offsets: e.modifiersData.arrow,
    position: "absolute",
    adaptive: !1,
    roundOffsets: s
  })))), e.attributes.popper = Object.assign({}, e.attributes.popper, {
    "data-popper-placement": e.placement
  });
}
var Pr = {
  name: "computeStyles",
  enabled: !0,
  phase: "beforeWrite",
  fn: Mr,
  data: {}
};
function Br(t) {
  var e = t.state;
  Object.keys(e.elements).forEach(function(n) {
    var o = e.styles[n] || {}, i = e.attributes[n] || {}, r = e.elements[n];
    !ge(r) || !Ae(r) || (Object.assign(r.style, o), Object.keys(i).forEach(function(a) {
      var l = i[a];
      l === !1 ? r.removeAttribute(a) : r.setAttribute(a, l === !0 ? "" : l);
    }));
  });
}
function Nr(t) {
  var e = t.state, n = {
    popper: {
      position: e.options.strategy,
      left: "0",
      top: "0",
      margin: "0"
    },
    arrow: {
      position: "absolute"
    },
    reference: {}
  };
  return Object.assign(e.elements.popper.style, n.popper), e.styles = n, e.elements.arrow && Object.assign(e.elements.arrow.style, n.arrow), function() {
    Object.keys(e.elements).forEach(function(o) {
      var i = e.elements[o], r = e.attributes[o] || {}, a = Object.keys(e.styles.hasOwnProperty(o) ? e.styles[o] : n[o]), l = a.reduce(function(s, c) {
        return s[c] = "", s;
      }, {});
      !ge(i) || !Ae(i) || (Object.assign(i.style, l), Object.keys(r).forEach(function(s) {
        i.removeAttribute(s);
      }));
    });
  };
}
var Rr = {
  name: "applyStyles",
  enabled: !0,
  phase: "write",
  fn: Br,
  effect: Nr,
  requires: ["computeStyles"]
}, Yr = [kr, $r, Pr, Rr], jr = /* @__PURE__ */ Sr({
  defaultModifiers: Yr
});
function Vr(t) {
  return t === "x" ? "y" : "x";
}
function Rt(t, e, n) {
  return Re(t, mt(e, n));
}
function Hr(t) {
  var e = t.state, n = t.options, o = t.name, i = n.mainAxis, r = i === void 0 ? !0 : i, a = n.altAxis, l = a === void 0 ? !1 : a, s = n.boundary, c = n.rootBoundary, d = n.altBoundary, u = n.padding, y = n.tether, b = y === void 0 ? !0 : y, p = n.tetherOffset, h = p === void 0 ? 0 : p, g = Bn(e, {
    boundary: s,
    rootBoundary: c,
    padding: u,
    altBoundary: d
  }), E = Oe(e.placement), x = nt(e.placement), w = !x, C = Pn(E), O = Vr(C), F = e.modifiersData.popperOffsets, m = e.rects.reference, T = e.rects.popper, v = typeof h == "function" ? h(Object.assign({}, e.rects, {
    placement: e.placement
  })) : h, D = {
    x: 0,
    y: 0
  };
  if (F) {
    if (r || l) {
      var S = C === "y" ? me : be, V = C === "y" ? _e : Te, k = C === "y" ? "height" : "width", H = F[C], re = F[C] + g[S], W = F[C] - g[V], le = b ? -T[k] / 2 : 0, U = x === tt ? m[k] : T[k], J = x === tt ? -T[k] : -m[k], K = e.elements.arrow, ve = b && K ? In(K) : {
        width: 0,
        height: 0
      }, Me = e.modifiersData["arrow#persistent"] ? e.modifiersData["arrow#persistent"].padding : Ro(), Dt = Me[S], je = Me[V], De = Rt(0, m[k], ve[k]), Et = w ? m[k] / 2 - le - De - Dt - v : U - De - Dt - v, Kt = w ? -m[k] / 2 + le + De + je + v : J + De + je + v, Xe = e.elements.arrow && Tt(e.elements.arrow), Qt = Xe ? C === "y" ? Xe.clientTop || 0 : Xe.clientLeft || 0 : 0, Yn = e.modifiersData.offset ? e.modifiersData.offset[e.placement][C] : 0, jn = F[C] + Et - Yn - Qt, Vn = F[C] + Kt - Yn;
      if (r) {
        var Hn = Rt(b ? mt(re, jn) : re, H, b ? Re(W, Vn) : W);
        F[C] = Hn, D[C] = Hn - H;
      }
      if (l) {
        var Uo = C === "x" ? me : be, zo = C === "x" ? _e : Te, xt = F[O], Wn = xt + g[Uo], Un = xt - g[zo], zn = Rt(b ? mt(Wn, jn) : Wn, xt, b ? Re(Un, Vn) : Un);
        F[O] = zn, D[O] = zn - xt;
      }
    }
    e.modifiersData[o] = D;
  }
}
var Wr = {
  name: "preventOverflow",
  enabled: !0,
  phase: "main",
  fn: Hr,
  requiresIfExists: ["offset"]
}, Ur = {
  left: "right",
  right: "left",
  bottom: "top",
  top: "bottom"
};
function Yt(t) {
  return t.replace(/left|right|bottom|top/g, function(e) {
    return Ur[e];
  });
}
var zr = {
  start: "end",
  end: "start"
};
function ho(t) {
  return t.replace(/start|end/g, function(e) {
    return zr[e];
  });
}
function Xr(t, e) {
  e === void 0 && (e = {});
  var n = e, o = n.placement, i = n.boundary, r = n.rootBoundary, a = n.padding, l = n.flipVariations, s = n.allowedAutoPlacements, c = s === void 0 ? Po : s, d = nt(o), u = d ? l ? uo : uo.filter(function(p) {
    return nt(p) === d;
  }) : Ct, y = u.filter(function(p) {
    return c.indexOf(p) >= 0;
  });
  y.length === 0 && (y = u);
  var b = y.reduce(function(p, h) {
    return p[h] = Bn(t, {
      placement: h,
      boundary: i,
      rootBoundary: r,
      padding: a
    })[Oe(h)], p;
  }, {});
  return Object.keys(b).sort(function(p, h) {
    return b[p] - b[h];
  });
}
function qr(t) {
  if (Oe(t) === Mn)
    return [];
  var e = Yt(t);
  return [ho(t), e, ho(e)];
}
function Gr(t) {
  var e = t.state, n = t.options, o = t.name;
  if (!e.modifiersData[o]._skip) {
    for (var i = n.mainAxis, r = i === void 0 ? !0 : i, a = n.altAxis, l = a === void 0 ? !0 : a, s = n.fallbackPlacements, c = n.padding, d = n.boundary, u = n.rootBoundary, y = n.altBoundary, b = n.flipVariations, p = b === void 0 ? !0 : b, h = n.allowedAutoPlacements, g = e.options.placement, E = Oe(g), x = E === g, w = s || (x || !p ? [Yt(g)] : qr(g)), C = [g].concat(w).reduce(function(je, De) {
      return je.concat(Oe(De) === Mn ? Xr(e, {
        placement: De,
        boundary: d,
        rootBoundary: u,
        padding: c,
        flipVariations: p,
        allowedAutoPlacements: h
      }) : De);
    }, []), O = e.rects.reference, F = e.rects.popper, m = /* @__PURE__ */ new Map(), T = !0, v = C[0], D = 0; D < C.length; D++) {
      var S = C[D], V = Oe(S), k = nt(S) === tt, H = [me, _e].indexOf(V) >= 0, re = H ? "width" : "height", W = Bn(e, {
        placement: S,
        boundary: d,
        rootBoundary: u,
        altBoundary: y,
        padding: c
      }), le = H ? k ? Te : be : k ? _e : me;
      O[re] > F[re] && (le = Yt(le));
      var U = Yt(le), J = [];
      if (r && J.push(W[V] <= 0), l && J.push(W[le] <= 0, W[U] <= 0), J.every(function(je) {
        return je;
      })) {
        v = S, T = !1;
        break;
      }
      m.set(S, J);
    }
    if (T)
      for (var K = p ? 3 : 1, ve = function(De) {
        var Et = C.find(function(Kt) {
          var Xe = m.get(Kt);
          if (Xe)
            return Xe.slice(0, De).every(function(Qt) {
              return Qt;
            });
        });
        if (Et)
          return v = Et, "break";
      }, Me = K; Me > 0; Me--) {
        var Dt = ve(Me);
        if (Dt === "break")
          break;
      }
    e.placement !== v && (e.modifiersData[o]._skip = !0, e.placement = v, e.reset = !0);
  }
}
var Jr = {
  name: "flip",
  enabled: !0,
  phase: "main",
  fn: Gr,
  requiresIfExists: ["offset"],
  data: {
    _skip: !1
  }
};
function Kr(t, e, n) {
  var o = Oe(t), i = [be, me].indexOf(o) >= 0 ? -1 : 1, r = typeof n == "function" ? n(Object.assign({}, e, {
    placement: t
  })) : n, a = r[0], l = r[1];
  return a = a || 0, l = (l || 0) * i, [be, Te].indexOf(o) >= 0 ? {
    x: l,
    y: a
  } : {
    x: a,
    y: l
  };
}
function Qr(t) {
  var e = t.state, n = t.options, o = t.name, i = n.offset, r = i === void 0 ? [0, 0] : i, a = Po.reduce(function(d, u) {
    return d[u] = Kr(u, e.rects, r), d;
  }, {}), l = a[e.placement], s = l.x, c = l.y;
  e.modifiersData.popperOffsets != null && (e.modifiersData.popperOffsets.x += s, e.modifiersData.popperOffsets.y += c), e.modifiersData[o] = a;
}
var Zr = {
  name: "offset",
  enabled: !0,
  phase: "main",
  requires: ["popperOffsets"],
  fn: Qr
}, ea = function(e, n) {
  return e = typeof e == "function" ? e(Object.assign({}, n.rects, {
    placement: n.placement
  })) : e, Yo(typeof e != "number" ? e : jo(e, Ct));
};
function ta(t) {
  var e, n = t.state, o = t.name, i = t.options, r = n.elements.arrow, a = n.modifiersData.popperOffsets, l = Oe(n.placement), s = Pn(l), c = [be, Te].indexOf(l) >= 0, d = c ? "height" : "width";
  if (!(!r || !a)) {
    var u = ea(i.padding, n), y = In(r), b = s === "y" ? me : be, p = s === "y" ? _e : Te, h = n.rects.reference[d] + n.rects.reference[s] - a[s] - n.rects.popper[d], g = a[s] - n.rects.reference[s], E = Tt(r), x = E ? s === "y" ? E.clientHeight || 0 : E.clientWidth || 0 : 0, w = h / 2 - g / 2, C = u[b], O = x - y[d] - u[p], F = x / 2 - y[d] / 2 + w, m = Rt(C, F, O), T = s;
    n.modifiersData[o] = (e = {}, e[T] = m, e.centerOffset = m - F, e);
  }
}
function na(t) {
  var e = t.state, n = t.options, o = n.element, i = o === void 0 ? "[data-popper-arrow]" : o;
  i != null && (typeof i == "string" && (i = e.elements.popper.querySelector(i), !i) || Bo(e.elements.popper, i) && (e.elements.arrow = i));
}
var oa = {
  name: "arrow",
  enabled: !0,
  phase: "main",
  fn: ta,
  effect: na,
  requires: ["popperOffsets"],
  requiresIfExists: ["preventOverflow"]
};
const pn = (t) => parseInt(t, 10);
function ia({
  arrowPadding: t,
  emit: e,
  locked: n,
  offsetDistance: o,
  offsetSkid: i,
  placement: r,
  popperNode: a,
  triggerNode: l
}) {
  const s = Zo({
    isOpen: !1,
    popperInstance: null
  }), c = (h) => {
    var g;
    (g = s.popperInstance) === null || g === void 0 || g.setOptions((E) => ({
      ...E,
      modifiers: [...E.modifiers, {
        name: "eventListeners",
        enabled: h
      }]
    }));
  }, d = () => c(!0), u = () => c(!1), y = () => {
    s.isOpen && (s.isOpen = !1, e("close:popper"));
  }, b = () => {
    s.isOpen || (s.isOpen = !0, e("open:popper"));
  };
  vt([() => s.isOpen, r], async ([h]) => {
    h ? (await p(), d()) : u();
  });
  const p = async () => {
    await yo(), s.popperInstance = jr(l.value, a.value, {
      placement: r.value,
      modifiers: [Wr, Jr, {
        name: "flip",
        enabled: !n.value
      }, oa, {
        name: "arrow",
        options: {
          padding: pn(t.value)
        }
      }, Zr, {
        name: "offset",
        options: {
          offset: [pn(i.value), pn(o.value)]
        }
      }]
    }), s.popperInstance.update();
  };
  return zt(() => {
    var h;
    (h = s.popperInstance) === null || h === void 0 || h.destroy();
  }), {
    ...mo(s),
    open: b,
    close: y
  };
}
const ra = {
  id: "arrow",
  "data-popper-arrow": ""
};
function aa(t, e) {
  return M(), P("div", ra);
}
function Vo(t, e) {
  e === void 0 && (e = {});
  var n = e.insertAt;
  if (!(!t || typeof document > "u")) {
    var o = document.head || document.getElementsByTagName("head")[0], i = document.createElement("style");
    i.type = "text/css", n === "top" && o.firstChild ? o.insertBefore(i, o.firstChild) : o.appendChild(i), i.styleSheet ? i.styleSheet.cssText = t : i.appendChild(document.createTextNode(t));
  }
}
var la = `
#arrow[data-v-20b7fd4a],
  #arrow[data-v-20b7fd4a]::before {
    transition: background 250ms ease-in-out;
    position: absolute;
    width: calc(10px - var(--popper-theme-border-width, 0px));
    height: calc(10px - var(--popper-theme-border-width, 0px));
    box-sizing: border-box;
    background: var(--popper-theme-background-color);
}
#arrow[data-v-20b7fd4a] {
    visibility: hidden;
}
#arrow[data-v-20b7fd4a]::before {
    visibility: visible;
    content: "";
    transform: rotate(45deg);
}

  /* Top arrow */
.popper[data-popper-placement^="top"] > #arrow[data-v-20b7fd4a] {
    bottom: -5px;
}
.popper[data-popper-placement^="top"] > #arrow[data-v-20b7fd4a]::before {
    border-right: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
    border-bottom: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
}

  /* Bottom arrow */
.popper[data-popper-placement^="bottom"] > #arrow[data-v-20b7fd4a] {
    top: -5px;
}
.popper[data-popper-placement^="bottom"] > #arrow[data-v-20b7fd4a]::before {
    border-left: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
    border-top: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
}

  /* Left arrow */
.popper[data-popper-placement^="left"] > #arrow[data-v-20b7fd4a] {
    right: -5px;
}
.popper[data-popper-placement^="left"] > #arrow[data-v-20b7fd4a]::before {
    border-right: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
    border-top: var(--popper-theme-border-width)
      var(--popper-theme-border-style) var(--popper-theme-border-color);
}

  /* Right arrow */
.popper[data-popper-placement^="right"] > #arrow[data-v-20b7fd4a] {
    left: -5px;
}
`;
Vo(la);
const Nn = {};
Nn.render = aa;
Nn.__scopeId = "data-v-20b7fd4a";
var sa = Nn;
const ua = ["onKeyup"];
var Ho = {
  props: {
    /**
     * Preferred placement (the "auto" placements will choose the side with most space.)
     */
    placement: {
      type: String,
      default: "bottom",
      validator: function(t) {
        return ["auto", "auto-start", "auto-end", "top", "top-start", "top-end", "bottom", "bottom-start", "bottom-end", "right", "right-start", "right-end", "left", "left-start", "left-end"].includes(t);
      }
    },
    /**
     * Disables automatically closing the popover when the user clicks away from it
     */
    disableClickAway: {
      type: Boolean,
      default: !1
    },
    /**
     * Offset in pixels along the trigger element
     */
    offsetSkid: {
      type: String,
      default: "0"
    },
    /**
     * Offset in pixels away from the trigger element
     */
    offsetDistance: {
      type: String,
      default: "12"
    },
    /**
     * Trigger the popper on hover
     */
    hover: {
      type: Boolean,
      default: !1
    },
    /**
     * Manually open/close the Popper, other events are ignored if this prop is set
     */
    show: {
      type: Boolean,
      default: null
    },
    /**
     * Disables the Popper. If it was already open, it will be closed.
     */
    disabled: {
      type: Boolean,
      default: !1
    },
    /**
     * Open the Popper after a delay (ms).
     */
    openDelay: {
      type: [Number, String],
      default: 0
    },
    /**
     * Close the Popper after a delay (ms).
     */
    closeDelay: {
      type: [Number, String],
      default: 0
    },
    /**
     * The z-index of the Popper.
     */
    zIndex: {
      type: [Number, String],
      default: 9999
    },
    /**
     * Display an arrow on the popper
     */
    arrow: {
      type: Boolean,
      default: !1
    },
    /**
     * Stop arrow from reaching the edge of the popper
     */
    arrowPadding: {
      type: String,
      default: "0"
    },
    /**
     * If the Popper should be interactive, it will close when clicked/hovered if false
     */
    interactive: {
      type: Boolean,
      default: !0
    },
    /**
     * Lock the Popper into place, it will not flip dynamically when it runs out of space if true
     */
    locked: {
      type: Boolean,
      default: !1
    },
    /**
     * If the content is just a simple string, it can be passed in as a prop
     */
    content: {
      type: String,
      default: null
    }
  },
  emits: ["open:popper", "close:popper"],
  setup(t, {
    emit: e
  }) {
    const n = t;
    qo((U) => ({
      c81fc0a4: t.zIndex
    }));
    const o = Go(), i = ue(null), r = ue(null), a = ue(null), l = ue(!1);
    yt(() => {
      const U = o.default();
      if (U && U.length > 1)
        return console.error(`[Popper]: The <Popper> component expects only one child element at its root. You passed ${U.length} child nodes.`);
    });
    const {
      arrowPadding: s,
      closeDelay: c,
      content: d,
      disableClickAway: u,
      disabled: y,
      interactive: b,
      locked: p,
      offsetDistance: h,
      offsetSkid: g,
      openDelay: E,
      placement: x,
      show: w
    } = mo(n), {
      isOpen: C,
      open: O,
      close: F
    } = ia({
      arrowPadding: s,
      emit: e,
      locked: p,
      offsetDistance: h,
      offsetSkid: g,
      placement: x,
      popperNode: r,
      triggerNode: a
    }), {
      hasContent: m
    } = er(o, r, d), T = z(() => w.value !== null), v = z(() => y.value || !m.value), D = z(() => C.value && !v.value), S = z(() => !u.value && !T.value), V = z(() => b.value ? `border: ${h.value}px solid transparent; margin: -${h.value}px;` : null), k = fn.debounce(O, E.value), H = fn.debounce(F, c.value), re = async () => {
      v.value || T.value || (H.clear(), k());
    }, W = async () => {
      T.value || (k.clear(), H());
    }, le = () => {
      C.value ? W() : re();
    };
    return vt([m, y], ([U, J]) => {
      C.value && (!U || J) && F();
    }), vt(C, (U) => {
      U ? l.value = !0 : fn.debounce(() => {
        l.value = !1;
      }, 200);
    }), qn(() => {
      T.value && (w.value ? k() : H());
    }), qn(() => {
      S.value && Zi(i, W);
    }), (U, J) => (M(), P("div", {
      class: "inline-block",
      style: ze(ee(V)),
      onMouseleave: J[2] || (J[2] = (K) => t.hover && W()),
      ref: (K, ve) => {
        ve.popperContainerNode = K, i.value = K;
      }
    }, [f("div", {
      ref: (K, ve) => {
        ve.triggerNode = K, a.value = K;
      },
      onMouseover: J[0] || (J[0] = (K) => t.hover && re()),
      onClick: le,
      onFocus: re,
      onKeyup: Jo(W, ["esc"])
    }, [hn(U.$slots, "default")], 40, ua), Ue(Ko, {
      name: "fade"
    }, {
      default: Lt(() => [fe(f("div", {
        onClick: J[1] || (J[1] = (K) => !ee(b) && W()),
        class: "popper",
        ref: (K, ve) => {
          ve.popperNode = K, r.value = K;
        }
      }, [hn(U.$slots, "content", {
        close: ee(F),
        isOpen: l.value
      }, () => [lt(we(ee(d)), 1)]), t.arrow ? (M(), Qo(sa, {
        key: 0
      })) : En("", !0)], 512), [[bo, ee(D)]])]),
      _: 3
    })], 36));
  }
}, ca = `
.inline-block[data-v-5784ed69] {
    display: inline-block;
}
.popper[data-v-5784ed69] {
    transition: background 250ms ease-in-out;
    background: var(--popper-theme-background-color);
    padding: var(--popper-theme-padding);
    color: var(--popper-theme-text-color);
    border-radius: var(--popper-theme-border-radius);
    border-width: var(--popper-theme-border-width);
    border-style: var(--popper-theme-border-style);
    border-color: var(--popper-theme-border-color);
    box-shadow: var(--popper-theme-box-shadow);
    z-index: var(--c81fc0a4);
}
.popper[data-v-5784ed69]:hover,
  .popper:hover > #arrow[data-v-5784ed69]::before {
    background: var(--popper-theme-background-color-hover);
}
.inline-block[data-v-5784ed69] {
    display: inline-block;
}
.fade-enter-active[data-v-5784ed69],
  .fade-leave-active[data-v-5784ed69] {
    transition: opacity 0.2s ease;
}
.fade-enter-from[data-v-5784ed69],
  .fade-leave-to[data-v-5784ed69] {
    opacity: 0;
}
`;
Vo(ca);
Ho.__scopeId = "data-v-5784ed69";
var da = /* @__PURE__ */ (() => {
  const t = Ho;
  return t.install = (e) => {
    e.component("Popper", t);
  }, t;
})();
const fa = (t) => {
  try {
    return JSON.parse(t);
  } catch {
    return null;
  }
}, pa = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20width='24'%20height='24'%20viewBox='0%200%2024%2024'%20fill='none'%20stroke='currentColor'%20stroke-width='2'%20stroke-linecap='round'%20stroke-linejoin='round'%20%3e%3cline%20x1='17'%20y1='10'%20x2='3'%20y2='10'%20/%3e%3cline%20x1='21'%20y1='6'%20x2='3'%20y2='6'%20/%3e%3cline%20x1='21'%20y1='14'%20x2='3'%20y2='14'%20/%3e%3cline%20x1='17'%20y1='18'%20x2='3'%20y2='18'%20/%3e%3c/svg%3e", va = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20xml:space='preserve'%20width='96'%20height='96'%3e%3cpath%20d='M12%2028h72a4%204%200%200%200%200-8H12a4%204%200%200%200%200%208zm8%208a4%204%200%200%200%200%208h56a4%204%200%200%200%200-8H20zm64%2016H12a4%204%200%200%200%200%208h72a4%204%200%200%200%200-8zm-8%2016H20a4%204%200%200%200%200%208h56a4%204%200%200%200%200-8z'/%3e%3c/svg%3e", ha = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20xml:space='preserve'%20width='96'%20height='96'%3e%3cpath%20d='M88%2024a4%204%200%200%200-4-4H12a4%204%200%200%200%200%208h72a4%204%200%200%200%204-4zm0%2016a4%204%200%200%200-4-4H28a4%204%200%200%200%200%208h56a4%204%200%200%200%204-4zM8%2056a4%204%200%200%200%204%204h72a4%204%200%200%200%200-8H12a4%204%200%200%200-4%204zm16%2016a4%204%200%200%200%204%204h56a4%204%200%200%200%200-8H28a4%204%200%200%200-4%204z'/%3e%3c/svg%3e", ga = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20width='24'%20height='24'%20viewBox='0%200%2024%2024'%3e%3cpath%20d='M8%2011h3v10h2V11h3l-4-4-4%204zM4%203v2h16V3H4z'/%3e%3c/svg%3e", ma = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20width='24'%20height='24'%20viewBox='0%200%2024%2024'%3e%3cpath%20d='M8%2019h3v4h2v-4h3l-4-4-4%204zm8-14h-3V1h-2v4H8l4%204%204-4zM4%2011v2h16v-2H4z'/%3e%3c/svg%3e", ba = "data:image/svg+xml,%3csvg%20xmlns='http://www.w3.org/2000/svg'%20width='24'%20height='24'%20viewBox='0%200%2024%2024'%3e%3cpath%20d='M16%2013h-3V3h-2v10H8l4%204%204-4zM4%2019v2h16v-2H4z'/%3e%3c/svg%3e", Q = [];
for (let t = 0; t < 256; ++t)
  Q.push((t + 256).toString(16).slice(1));
function ya(t, e = 0) {
  return (Q[t[e + 0]] + Q[t[e + 1]] + Q[t[e + 2]] + Q[t[e + 3]] + "-" + Q[t[e + 4]] + Q[t[e + 5]] + "-" + Q[t[e + 6]] + Q[t[e + 7]] + "-" + Q[t[e + 8]] + Q[t[e + 9]] + "-" + Q[t[e + 10]] + Q[t[e + 11]] + Q[t[e + 12]] + Q[t[e + 13]] + Q[t[e + 14]] + Q[t[e + 15]]).toLowerCase();
}
let vn;
const wa = new Uint8Array(16);
function _a() {
  if (!vn) {
    if (typeof crypto > "u" || !crypto.getRandomValues)
      throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");
    vn = crypto.getRandomValues.bind(crypto);
  }
  return vn(wa);
}
const Ta = typeof crypto < "u" && crypto.randomUUID && crypto.randomUUID.bind(crypto), go = { randomUUID: Ta };
function Wo(t, e, n) {
  var i;
  if (go.randomUUID && !e && !t)
    return go.randomUUID();
  t = t || {};
  const o = t.random ?? ((i = t.rng) == null ? void 0 : i.call(t)) ?? _a();
  if (o.length < 16)
    throw new Error("Random bytes length must be >= 16");
  if (o[6] = o[6] & 15 | 64, o[8] = o[8] & 63 | 128, e) {
    if (n = n || 0, n < 0 || n + 16 > e.length)
      throw new RangeError(`UUID byte range ${n}:${n + 15} is out of buffer bounds`);
    for (let r = 0; r < 16; ++r)
      e[n + r] = o[r];
    return e;
  }
  return ya(o);
}
const Jt = (t) => (xn("data-v-52705289"), t = t(), On(), t), Ca = {
  key: 0,
  class: "popup-edit-label"
}, Da = { class: "popup-content" }, Ea = { class: "input-group" }, xa = /* @__PURE__ */ Jt(() => /* @__PURE__ */ f("label", null, "Tiêu đề:", -1)), Oa = { class: "input-group" }, Sa = /* @__PURE__ */ Jt(() => /* @__PURE__ */ f("label", null, "Màu chữ:", -1)), Aa = { class: "color-picker" }, ka = { class: "color-input-group" }, Fa = { class: "quick-colors" }, $a = ["onClick"], La = { class: "input-group" }, Ia = /* @__PURE__ */ Jt(() => /* @__PURE__ */ f("label", null, "Màu nền:", -1)), Ma = { class: "color-picker" }, Pa = { class: "color-input-group" }, Ba = { class: "quick-colors" }, Na = ["onClick"], Ra = { class: "input-group" }, Ya = /* @__PURE__ */ Jt(() => /* @__PURE__ */ f("label", null, "Style:", -1)), ja = { class: "style-buttons" }, Va = { class: "actions" }, Ha = ["disabled"], Wa = /* @__PURE__ */ bt({
  __name: "PopupEditLabel",
  emits: ["save"],
  setup(t, { expose: e, emit: n }) {
    const o = n, i = ue(), r = ue(!1), a = ue({
      title: "",
      code: "",
      style: {
        color: "#000000",
        backgroundColor: "#ffffff",
        fontWeight: "normal",
        fontStyle: "normal",
        textDecoration: "none"
      }
    }), l = [
      "#000000",
      "#ffffff",
      "#ff0000",
      "#00ff00",
      "#0000ff",
      "#ffff00",
      "#ff00ff",
      "#00ffff",
      "#ffa500",
      "#800080"
    ], s = [
      "#000000",
      "#ffffff",
      "#ff0000",
      "#00ff00",
      "#0000ff",
      "#ffff00",
      "#ff00ff",
      "#00ffff",
      "#ffa500",
      "#800080",
      "transparent"
    ], c = (b) => {
      if (a.value.style)
        switch (b) {
          case "fontWeight":
            a.value.style.fontWeight = a.value.style.fontWeight === "bold" ? "normal" : "bold";
            break;
          case "fontStyle":
            a.value.style.fontStyle = a.value.style.fontStyle === "italic" ? "normal" : "italic";
            break;
          case "textDecoration":
            a.value.style.textDecoration = a.value.style.textDecoration === "underline" ? "none" : "underline";
            break;
        }
    }, d = () => {
      r.value = !1;
    }, u = () => {
      o("save", a.value), r.value = !1;
    };
    return e({
      show: (b) => {
        var p, h, g, E, x;
        r.value = !0, b ? a.value = {
          title: b.title,
          code: b.code,
          style: {
            color: ((p = b.style) == null ? void 0 : p.color) || "#000000",
            backgroundColor: ((h = b.style) == null ? void 0 : h.backgroundColor) || "transparent",
            fontWeight: ((g = b.style) == null ? void 0 : g.fontWeight) || "normal",
            fontStyle: ((E = b.style) == null ? void 0 : E.fontStyle) || "normal",
            textDecoration: ((x = b.style) == null ? void 0 : x.textDecoration) || "none"
          }
        } : a.value = {
          title: "",
          code: Wo(),
          style: {
            color: "#000000",
            backgroundColor: "transparent",
            fontWeight: "normal",
            fontStyle: "normal",
            textDecoration: "none"
          }
        }, yo(() => {
          var w;
          (w = i.value) == null || w.focus();
        });
      }
    }), (b, p) => r.value ? (M(), P("div", Ca, [
      f("div", Da, [
        f("div", Ea, [
          xa,
          fe(f("input", {
            ref_key: "inputTitleRef",
            ref: i,
            class: "input-title",
            "onUpdate:modelValue": p[0] || (p[0] = (h) => a.value.title = h),
            type: "text",
            placeholder: "Nhập tiêu đề..."
          }, null, 512), [
            [ke, a.value.title]
          ])
        ]),
        f("div", Oa, [
          Sa,
          f("div", Aa, [
            f("div", ka, [
              fe(f("input", {
                "onUpdate:modelValue": p[1] || (p[1] = (h) => a.value.style.color = h),
                type: "color"
              }, null, 512), [
                [ke, a.value.style.color]
              ]),
              fe(f("input", {
                "onUpdate:modelValue": p[2] || (p[2] = (h) => a.value.style.color = h),
                type: "text",
                class: "hex-input",
                placeholder: "#000000"
              }, null, 512), [
                [ke, a.value.style.color]
              ])
            ]),
            f("div", Fa, [
              (M(), P(ne, null, oe(l, (h) => f("button", {
                key: h,
                style: ze({ backgroundColor: h }),
                onClick: (g) => a.value.style.color = h
              }, null, 12, $a)), 64))
            ])
          ])
        ]),
        f("div", La, [
          Ia,
          f("div", Ma, [
            f("div", Pa, [
              fe(f("input", {
                "onUpdate:modelValue": p[3] || (p[3] = (h) => a.value.style.backgroundColor = h),
                type: "color"
              }, null, 512), [
                [ke, a.value.style.backgroundColor]
              ]),
              fe(f("input", {
                "onUpdate:modelValue": p[4] || (p[4] = (h) => a.value.style.backgroundColor = h),
                type: "text",
                class: "hex-input",
                placeholder: "#ffffff"
              }, null, 512), [
                [ke, a.value.style.backgroundColor]
              ])
            ]),
            f("div", Ba, [
              (M(), P(ne, null, oe(s, (h) => f("button", {
                key: h,
                style: ze({ backgroundColor: h }),
                onClick: (g) => a.value.style.backgroundColor = h
              }, null, 12, Na)), 64))
            ])
          ])
        ]),
        f("div", Ra, [
          Ya,
          f("div", ja, [
            f("button", {
              class: q({ active: a.value.style.fontWeight === "bold" }),
              onClick: p[5] || (p[5] = (h) => c("fontWeight"))
            }, " B ", 2),
            f("button", {
              class: q({ active: a.value.style.fontStyle === "italic" }),
              onClick: p[6] || (p[6] = (h) => c("fontStyle"))
            }, " I ", 2),
            f("button", {
              class: q({ active: a.value.style.textDecoration === "underline" }),
              onClick: p[7] || (p[7] = (h) => c("textDecoration"))
            }, " U ", 2)
          ])
        ]),
        f("div", Va, [
          f("button", {
            class: "btn-cancel",
            onClick: d
          }, "Hủy"),
          f("button", {
            class: "btn-save",
            onClick: u,
            disabled: !a.value.title
          }, "Lưu", 8, Ha)
        ])
      ])
    ])) : En("", !0);
  }
}), Ua = /* @__PURE__ */ Xt(Wa, [["__scopeId", "data-v-52705289"]]), ie = (t) => (xn("data-v-7a1f15f0"), t = t(), On(), t), za = { class: "grid-col-2" }, Xa = { class: "edit-columns" }, qa = { class: "justify-content-space-between" }, Ga = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("h5", null, " Columns ", -1)), Ja = ["disabled"], Ka = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("hr", { style: { margin: "5px 0" } }, null, -1)), Qa = ["onClick"], Za = ["onDrop", "onDragover", "onDragleave"], el = { class: "align-items-center" }, tl = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("span", { class: "handle" }, "☰", -1)), nl = ["disabled"], ol = { class: "popover-action" }, il = ["onClick"], rl = ["src"], al = ["onClick"], ll = ["src"], sl = ["onClick"], ul = ["src"], cl = { style: { "margin-top": "4px" } }, dl = ["onClick"], fl = ["src"], pl = ["onClick"], vl = ["src"], hl = ["onClick"], gl = ["src"], ml = {
  style: { "margin-top": "4px" },
  class: "div-input"
}, bl = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("label", { class: "label" }, "width:", -1)), yl = ["onUpdate:modelValue"], wl = {
  style: { "margin-top": "4px" },
  class: "div-input"
}, _l = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("label", { class: "label" }, "min-width:", -1)), Tl = ["onUpdate:modelValue"], Cl = {
  style: { "margin-top": "4px" },
  class: "div-input"
}, Dl = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("label", { class: "label" }, "max-width:", -1)), El = ["onUpdate:modelValue"], xl = ["disabled", "onUpdate:modelValue"], Ol = { class: "list-selected-field" }, Sl = ["src"], Al = { key: 1 }, kl = { class: "no-data" }, Fl = ["onClick", "disabled"], $l = { class: "edit-columns" }, Ll = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("h5", null, "Fields", -1)), Il = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("hr", { style: { margin: "5px 0" } }, null, -1)), Ml = { class: "list-field custom-scroll" }, Pl = { class: "label" }, Bl = ["onDragstart", "onDblclick"], Nl = { class: "edit-columns etc-field custom-scroll" }, Rl = { class: "justify-content-space-between" }, Yl = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("h5", null, " Labels ", -1)), jl = ["disabled"], Vl = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("hr", { style: { margin: "5px 0" } }, null, -1)), Hl = { class: "list-field-symbol" }, Wl = ["onClick", "onDblclick", "onDragstart"], Ul = { style: { "margin-top": "10px" } }, zl = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("h5", null, "Actions", -1)), Xl = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("hr", { style: { margin: "5px 0" } }, null, -1)), ql = { class: "list-field-symbol" }, Gl = ["onDblclick", "onDragstart"], Jl = { style: { "margin-top": "10px" } }, Kl = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("h5", null, "Separator", -1)), Ql = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("hr", { style: { margin: "5px 0" } }, null, -1)), Zl = { class: "list-field-symbol" }, es = ["onDblclick", "onDragstart"], ts = { style: { "margin-top": "10px" } }, ns = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("h5", null, "Icons", -1)), os = /* @__PURE__ */ ie(() => /* @__PURE__ */ f("hr", { style: { margin: "5px 0" } }, null, -1)), is = { class: "list-field-symbol" }, rs = ["onDblclick", "src", "onDragstart"], as = /* @__PURE__ */ bt({
  __name: "TableEditor",
  props: {
    modelValue: {},
    labels: {},
    vfFields: { default: () => [] },
    actions: { default: () => [] },
    icons: { default: () => [] },
    height: { default: 390 },
    disabled: { type: Boolean, default: !1 }
  },
  emits: ["update:modelValue", "update:labels", "error"],
  setup(t, { emit: e }) {
    const n = t, o = e, i = z({
      get() {
        return n.modelValue;
      },
      set(m) {
        o("update:modelValue", m);
      }
    }), r = z({
      get() {
        return n.labels || [];
      },
      set(m) {
        o("update:labels", m);
      }
    }), a = z(() => r.value.map((m) => ({
      vfCode: m.code,
      vfTitle: m.title,
      vfType: A.LABEL,
      vfAcutalField: m.code,
      vfActualFieldTitle: m.title
    }))), l = z(() => [...gn, ...n.actions, ...n.icons, ...n.vfFields, ...a.value]), s = z(() => l.value.reduce((m, T) => (m[T.vfCode] = T, m), {})), c = ue(-1), d = z(() => {
      const m = {}, T = [];
      for (const v of n.vfFields) {
        const D = (v == null ? void 0 : v.vfAcutalField) || "";
        m[D] === void 0 ? (T.push({
          title: v.vfActualFieldTitle || "",
          field: D,
          variants: [v]
        }), m[D] = T.length - 1) : T[m[D]].variants.push(v);
      }
      return T;
    }), u = () => {
      o("update:modelValue", [
        ...n.modelValue,
        {
          title: "",
          fieldCodes: [],
          isDrag: !1
        }
      ]);
    }, y = (m, T) => {
      m.dataTransfer.setData("text", JSON.stringify(T));
    }, b = (m, T) => {
      if (n.disabled)
        return !1;
      m.preventDefault(), T.isDrag = !0;
    }, p = (m, T) => {
      if (n.disabled)
        return !1;
      m.preventDefault(), T.isDrag = !1;
    }, h = (m, T, v) => {
      if (n.disabled)
        return !1;
      m.preventDefault();
      const D = fa(m.dataTransfer.getData("text"));
      D && D.vfCode && T.fieldCodes.push(D.vfCode), T.isDrag = !1, c.value = v;
    }, g = (m) => {
      const T = n.modelValue, v = T[m];
      v.fieldCodes.length > 0 ? v.fieldCodes.pop() : (T.splice(m, 1), c.value = -1), o("update:modelValue", T);
    }, E = (m) => {
      if (!n.disabled)
        if (c.value >= 0) {
          const T = i.value[c.value];
          T && T.fieldCodes.push(m.vfCode);
        } else
          o("error", "Hãy chọn column để thêm");
    }, x = ue(), w = z(() => (m) => {
      const T = r.value.find((v) => v.code === m.vfCode);
      return (T == null ? void 0 : T.style) || {};
    }), C = () => {
      var m;
      (m = x.value) == null || m.show();
    }, O = (m) => {
      var v;
      const T = r.value.find((D) => D.code === m.vfCode);
      T && ((v = x.value) == null || v.show(T));
    }, F = (m) => {
      console.log("handleSaveLabel", m);
      const T = r.value.find((v) => v.code === m.code);
      T ? (T.title = m.title, T.style = m.style) : r.value.push(m), o("update:labels", r.value);
    };
    return (m, T) => (M(), P("div", {
      class: "dynamic-table-edit box box-grid",
      style: ze({ height: `${m.height}px` })
    }, [
      f("div", za, [
        f("div", Xa, [
          f("div", qa, [
            Ga,
            f("div", null, [
              f("button", {
                class: "btn-plus",
                disabled: m.disabled,
                onClick: u
              }, "✚", 8, Ja)
            ])
          ]),
          Ka,
          Ue(ee(Ki), {
            tag: "ul",
            modelValue: i.value,
            "onUpdate:modelValue": T[0] || (T[0] = (v) => i.value = v),
            handle: ".handle",
            "ghost-class": "ghost",
            sort: !m.disabled,
            class: "dragArea list-group custom-scroll"
          }, {
            default: Lt(() => [
              (M(!0), P(ne, null, oe(i.value, (v, D) => (M(), P("li", {
                key: D,
                class: q(["list-group-item", { hover: v.isDrag, active: c.value === D }]),
                onClick: (S) => !m.disabled && (c.value = D)
              }, [
                f("div", {
                  class: "label align-items-center",
                  onDrop: (S) => h(S, v, D),
                  onDragover: (S) => b(S, v),
                  onDragleave: (S) => p(S, v)
                }, [
                  f("div", el, [
                    tl,
                    Ue(ee(da), {
                      placement: "right-start",
                      arrow: "",
                      class: "popper-wrapper"
                    }, {
                      content: Lt(() => [
                        f("div", ol, [
                          f("div", null, [
                            f("button", {
                              class: q(["btn-more", { active: (v.align || "left") === "left" }]),
                              onClick: (S) => v.align = "left"
                            }, [
                              f("img", { src: ee(pa) }, null, 8, rl)
                            ], 10, il),
                            f("button", {
                              class: q(["btn-more", { active: v.align === "center" }]),
                              onClick: (S) => v.align = "center"
                            }, [
                              f("img", { src: ee(va) }, null, 8, ll)
                            ], 10, al),
                            f("button", {
                              class: q(["btn-more", { active: v.align === "right" }]),
                              onClick: (S) => v.align = "right"
                            }, [
                              f("img", { src: ee(ha) }, null, 8, ul)
                            ], 10, sl)
                          ]),
                          f("div", cl, [
                            f("button", {
                              class: q(["btn-more", { active: (v.vAlign || "top") === "top" }]),
                              onClick: (S) => v.vAlign = "top"
                            }, [
                              f("img", { src: ee(ga) }, null, 8, fl)
                            ], 10, dl),
                            f("button", {
                              class: q(["btn-more", { active: v.vAlign === "middle" }]),
                              onClick: (S) => v.vAlign = "middle"
                            }, [
                              f("img", { src: ee(ma) }, null, 8, vl)
                            ], 10, pl),
                            f("button", {
                              class: q(["btn-more", { active: v.vAlign === "bottom" }]),
                              onClick: (S) => v.vAlign = "bottom"
                            }, [
                              f("img", { src: ee(ba) }, null, 8, gl)
                            ], 10, hl)
                          ]),
                          f("div", ml, [
                            bl,
                            lt(),
                            fe(f("input", {
                              type: "text",
                              "onUpdate:modelValue": (S) => v.width = S,
                              placeholder: "# px | %"
                            }, null, 8, yl), [
                              [ke, v.width]
                            ])
                          ]),
                          f("div", wl, [
                            _l,
                            lt(),
                            fe(f("input", {
                              type: "text",
                              "onUpdate:modelValue": (S) => v.minWidth = S,
                              placeholder: "# px | %"
                            }, null, 8, Tl), [
                              [ke, v.minWidth]
                            ])
                          ]),
                          f("div", Cl, [
                            Dl,
                            lt(),
                            fe(f("input", {
                              type: "text",
                              "onUpdate:modelValue": (S) => v.maxWidth = S,
                              placeholder: "# px | %"
                            }, null, 8, El), [
                              [ke, v.maxWidth]
                            ])
                          ])
                        ])
                      ]),
                      default: Lt(() => [
                        f("button", {
                          class: "btn-more",
                          disabled: m.disabled
                        }, "⋯", 8, nl)
                      ]),
                      _: 2
                    }, 1024),
                    fe(f("input", {
                      disabled: m.disabled,
                      class: "input-title",
                      type: "text",
                      "onUpdate:modelValue": (S) => v.title = S,
                      placeholder: "Column name"
                    }, null, 8, xl), [
                      [ke, v.title]
                    ])
                  ]),
                  f("ul", Ol, [
                    (M(!0), P(ne, null, oe(v.fieldCodes, (S) => {
                      var V, k, H;
                      return M(), P("li", { key: S }, [
                        ((V = s.value[S]) == null ? void 0 : V.vfType) === ee(A).ICON ? (M(), P("img", {
                          key: 0,
                          class: "icon-selected",
                          src: (k = s.value[S]) == null ? void 0 : k.value
                        }, null, 8, Sl)) : (M(), P("span", Al, we((H = s.value[S]) == null ? void 0 : H.vfTitle), 1))
                      ]);
                    }), 128)),
                    fe(f("li", kl, "Kéo field vào đây", 512), [
                      [bo, !v.fieldCodes.length]
                    ])
                  ])
                ], 40, Za),
                f("div", null, [
                  f("button", {
                    class: "btn btn-close",
                    onClick: ti((S) => g(D), ["stop"]),
                    disabled: m.disabled
                  }, " ✘ ", 8, Fl)
                ])
              ], 10, Qa))), 128))
            ]),
            _: 1
          }, 8, ["modelValue", "sort"])
        ]),
        f("div", $l, [
          Ll,
          Il,
          f("ul", Ml, [
            (M(!0), P(ne, null, oe(d.value, (v) => (M(), P("li", {
              key: v.field
            }, [
              f("div", Pl, we(v.title) + ":", 1),
              (M(!0), P(ne, null, oe(v.variants, (D) => (M(), P("div", {
                class: q(["item", { disabled: m.disabled }]),
                draggable: "true",
                onDragstart: (S) => y(S, D),
                key: D.vfCode,
                onDblclick: (S) => E(D)
              }, we(D.vfTitle), 43, Bl))), 128))
            ]))), 128))
          ])
        ]),
        f("div", Nl, [
          f("div", null, [
            f("div", Rl, [
              Yl,
              f("div", null, [
                f("button", {
                  class: "btn-plus",
                  disabled: m.disabled,
                  onClick: C
                }, "✚", 8, jl)
              ])
            ]),
            Vl,
            f("ul", Hl, [
              (M(!0), P(ne, null, oe(a.value, (v) => (M(), P("li", {
                key: v.vfCode
              }, [
                f("div", {
                  onClick: (D) => !m.disabled && O(v),
                  style: ze(w.value(v)),
                  onDblclick: (D) => E(v),
                  class: q(["item btn", { disabled: m.disabled }]),
                  draggable: "true",
                  onDragstart: (D) => y(D, v)
                }, we(v.vfTitle), 47, Wl)
              ]))), 128))
            ])
          ]),
          f("div", Ul, [
            zl,
            Xl,
            f("ul", ql, [
              (M(!0), P(ne, null, oe(m.actions, (v) => (M(), P("li", {
                key: v.vfAcutalField
              }, [
                f("div", {
                  onDblclick: (D) => E(v),
                  class: q(["item btn", { disabled: m.disabled }]),
                  draggable: "true",
                  onDragstart: (D) => y(D, v)
                }, we(v.vfTitle), 43, Gl)
              ]))), 128))
            ])
          ]),
          f("div", Jl, [
            Kl,
            Ql,
            f("ul", Zl, [
              (M(!0), P(ne, null, oe(ee(gn), (v) => (M(), P("li", {
                key: v.vfAcutalField
              }, [
                f("div", {
                  onDblclick: (D) => E(v),
                  class: q(["item", { disabled: m.disabled }]),
                  draggable: "true",
                  onDragstart: (D) => y(D, v)
                }, we(v.vfTitle), 43, es)
              ]))), 128))
            ])
          ]),
          f("div", ts, [
            ns,
            os,
            f("ul", is, [
              (M(!0), P(ne, null, oe(m.icons, (v) => (M(), P("li", {
                key: v.vfAcutalField
              }, [
                f("img", {
                  onDblclick: (D) => E(v),
                  src: v.value,
                  class: q(["icon", { disabled: m.disabled }]),
                  draggable: "true",
                  onDragstart: (D) => y(D, v)
                }, null, 42, rs)
              ]))), 128))
            ])
          ])
        ])
      ]),
      Ue(Ua, {
        ref_key: "popupEditLabelRef",
        ref: x,
        onSave: F
      }, null, 512)
    ], 4));
  }
}), ls = /* @__PURE__ */ Xt(as, [["__scopeId", "data-v-7a1f15f0"]]), Rn = (t) => (xn("data-v-43aa048c"), t = t(), On(), t), ss = { class: "flexi-table" }, us = { class: "table-controls" }, cs = { class: "layout-selector" }, ds = /* @__PURE__ */ Rn(() => /* @__PURE__ */ f("h4", null, "Layout: ", -1)), fs = { class: "dropdown" }, ps = ["value"], vs = { class: "quick-layouts" }, hs = ["onClick"], gs = {
  key: 0,
  class: "editor-popup"
}, ms = { class: "editor-content" }, bs = { class: "editor-header" }, ys = /* @__PURE__ */ Rn(() => /* @__PURE__ */ f("h3", null, "Tùy chỉnh bảng", -1)), ws = { class: "editor-body" }, _s = { class: "editor-actions" }, Ts = /* @__PURE__ */ Rn(() => /* @__PURE__ */ f("h4", null, "Layout:", -1)), Cs = { class: "dropdown" }, Ds = ["value"], Es = ["disabled"], xs = ["disabled"], Os = ["disabled"], Ss = /* @__PURE__ */ bt({
  __name: "FlexiTable",
  props: {
    modelValue: {},
    layouts: { default: () => [] },
    templates: { default: () => [] },
    actions: { default: () => [] },
    icons: { default: () => [] },
    data: { default: () => [] },
    height: {},
    fixed: { type: Boolean }
  },
  emits: ["update:modelValue", "onCta", "error", "save", "remove", "setDefault"],
  setup(t, { emit: e }) {
    const n = t, o = e, i = ue(!1), r = z({
      get() {
        return n.modelValue;
      },
      set(w) {
        o("update:modelValue", w);
      }
    }), a = z(() => n.layouts.find((w) => w.id === r.value)), l = (w) => {
      o("error", w);
    }, s = (w, C, O) => {
      o("onCta", w, C, O);
    }, c = ue([]), d = ue(""), u = z(() => c.value.find((w) => w.id === d.value)), y = z({
      get() {
        var w;
        return ((w = u.value) == null ? void 0 : w.columns) || [];
      },
      set(w) {
        u.value.columns = w;
      }
    }), b = () => {
      i.value = !0, d.value = r.value, c.value = JSON.parse(JSON.stringify(n.layouts || [])).map((w) => ({
        ...w,
        isSave: !0
      }));
    }, p = () => {
    }, h = () => {
      var O;
      const w = Wo(), C = {
        ...JSON.parse(JSON.stringify(u.value)),
        isSave: !1,
        isSystem: !1,
        isDefault: !1,
        id: w,
        title: `${((O = u.value) == null ? void 0 : O.title) || ""} clone`
      };
      c.value.push(C), d.value = w;
    }, g = () => {
      var O;
      const w = d.value, C = () => {
        const F = c.value.findIndex((m) => m.id === w);
        c.value.splice(F, 1), d.value = c.value[0].id || "";
      };
      (O = u.value) != null && O.isSave ? o("remove", w, () => {
        C();
      }) : C();
    }, E = () => {
      const w = JSON.parse(JSON.stringify(u.value));
      delete w.isSave, o("save", w, () => {
        u.value && (u.value.isSave = !0);
      });
    }, x = () => {
      o("setDefault", d.value, () => {
      });
    };
    return yt(() => {
    }), (w, C) => {
      var O, F, m, T, v, D, S, V;
      return M(), P("div", ss, [
        f("div", us, [
          f("div", cs, [
            ds,
            f("div", fs, [
              fe(f("select", {
                "onUpdate:modelValue": C[0] || (C[0] = (k) => r.value = k)
              }, [
                (M(!0), P(ne, null, oe(w.layouts, (k) => (M(), P("option", {
                  key: k.id,
                  value: k.id
                }, we(k.title), 9, ps))), 128))
              ], 512), [
                [Gn, r.value]
              ])
            ]),
            f("div", vs, [
              (M(!0), P(ne, null, oe(w.layouts, (k) => (M(), P("button", {
                key: k.id,
                onClick: (H) => r.value = k.id,
                class: q({ active: r.value === k.id })
              }, we(k.title), 11, hs))), 128))
            ])
          ]),
          f("div", { class: "settings" }, [
            f("button", { onClick: b }, " ⚙️ ")
          ])
        ]),
        Ue(Jn, {
          columns: ((O = a.value) == null ? void 0 : O.columns) || [],
          labels: ((F = a.value) == null ? void 0 : F.labels) || [],
          templates: [...w.templates, ...w.actions, ...w.icons],
          data: w.data,
          height: w.height,
          fixed: w.fixed,
          onOnCta: s
        }, null, 8, ["columns", "labels", "templates", "data", "height", "fixed"]),
        i.value ? (M(), P("div", gs, [
          f("div", {
            class: "editor-overlay",
            onClick: C[1] || (C[1] = (k) => i.value = !1)
          }),
          f("div", ms, [
            f("div", bs, [
              ys,
              f("button", {
                onClick: C[2] || (C[2] = (k) => i.value = !1)
              }, "✕")
            ]),
            f("div", ws, [
              Ue(Jn, {
                columns: y.value,
                labels: ((m = u.value) == null ? void 0 : m.labels) || [],
                templates: [...w.templates, ...w.actions, ...w.icons],
                data: w.data,
                height: 250,
                fixed: !0
              }, null, 8, ["columns", "labels", "templates", "data"]),
              f("div", _s, [
                Ts,
                f("div", Cs, [
                  fe(f("select", {
                    "onUpdate:modelValue": C[3] || (C[3] = (k) => d.value = k),
                    onChange: p
                  }, [
                    (M(!0), P(ne, null, oe(c.value, (k) => (M(), P("option", {
                      key: k.id,
                      value: k.id
                    }, we(k.title), 9, Ds))), 128))
                  ], 544), [
                    [Gn, d.value]
                  ])
                ]),
                f("button", { onClick: h }, " Clone "),
                f("button", {
                  disabled: (T = u.value) == null ? void 0 : T.isSystem,
                  onClick: g
                }, " Xóa ", 8, Es),
                f("button", {
                  disabled: (v = u.value) == null ? void 0 : v.isSystem,
                  onClick: E
                }, " Lưu ", 8, xs),
                f("button", {
                  disabled: !((D = u.value) != null && D.isSave) || ((S = u.value) == null ? void 0 : S.id) === r.value,
                  onClick: x
                }, " Default ", 8, Os)
              ]),
              Ue(ls, {
                modelValue: y.value,
                "onUpdate:modelValue": C[4] || (C[4] = (k) => y.value = k),
                labels: u.value.labels,
                "onUpdate:labels": C[5] || (C[5] = (k) => u.value.labels = k),
                "vf-fields": w.templates,
                actions: w.actions,
                icons: w.icons,
                height: 450,
                disabled: (V = u.value) == null ? void 0 : V.isSystem,
                onError: l
              }, null, 8, ["modelValue", "labels", "vf-fields", "actions", "icons", "disabled"])
            ])
          ])
        ])) : En("", !0)
      ]);
    };
  }
}), ks = /* @__PURE__ */ Xt(Ss, [["__scopeId", "data-v-43aa048c"]]);
export {
  Jn as DynamicTable,
  ks as FlexiTable,
  ls as TableEditor,
  A as VfType
};
